<?php
/**
 * API全般
 */
class ApiController extends AppController {
	//var $scaffold;
	var $name = 'Api';
	var $uses = array('Admin','Api','Sbblog','Sbblogdetail','Account','AccountApplication','Sbbconf','Certificationlog','Schedule','Application','Information',"Appmessage","Appschedule","Sbmconf","SbblogVer3","SbblogdetailVer3","CglogVer3","Actionlog",'Sbblog','MaintenanceSchedule', 'SbcStatusHistory', 'RemoteSettingsAccount');
	var $helpers = array('Html', 'Form', 'Number', 'Cache' );
	var $pageTitle = "api";
	var $components = array("Cmd",'Maintenance', 'SbcLogin', 'Schedules');
	var $layout = false;
	var $debug = false;
	var $autoRender = false;
	//var $cacheAction = array('getconf' => 6600);

	function beforeFilter() {
		parent::beforeFilter();
		Configure::write('debug', 0);
		require_once(APP. 'controllers' . DS . 'components' . DS . 'schedules.php');
		$this->Schedules = new SchedulesComponent;
	}
	
	/**
	 * プロパティ
	 */
	function sbm_property(){
		header("Content-type: text/plain;charset=UTF-8;");
		echo "encoding=UTF-8\r\n";
		exit;
	}
	
	/* コンストラクタ */
	function __construct(){
		parent::__construct();
	}
	
	function convertSJIS2UTF8(){
		return $this->render('convert_sjis_2_utf8');
	}

	//SBMによる電源Onを3分以内にしたか
	function isPowerOnFromSBM($uid) {
		$this->layout = false;
		$ret = 'false';
		$account = $this->Account->find("Account.ACCOUNT_ID = '{$uid}'", array('Account.sbc_start'));
		if(!empty($account)) {
			$sbc_start = strtotime($account['Account']['sbc_start']);
			$now = time();

			if($now - $sbc_start < 180) {
				$ret = 'true';
			}
		}
		echo $ret;
		exit;
	}

	/**
	 * ハートビート　無ログイン通知のための
	 */
	function _heartbeat($id,$type=null){
		#api/login
		#api/getinfo
		#api/getconf
		#api/uploadlog
		#api/getconfdate
		#api/getcurrent
		
		$id = (int)$id;
		$u = $this->_loadData($id);
		if(!empty($u)){
			$ua = $_SERVER['HTTP_USER_AGENT'];
			if(eregi('Secure Back Client Version ([0-9.]+)', $ua, $match)) {
				$sbc_version = $match[1];
			}
			$this->Account->id = $u['Account']['ACCOUNT_ID'];
			$this->Account->saveField("heartbeat",date("Y-m-d H:i:s"));
			$this->Account->saveField("heartbeat_type",$type);
			if(preg_match('/^Secure Back Client.*$/', $ua)) {
				$this->Account->saveField("user_agent",$ua);
				$regex_ip = "/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/";
				if(empty($u['Account']['wmi_win_ipaddress']) || preg_match($regex_ip, $u['Account']['wmi_win_ipaddress'])) {
					$this->Account->SaveField("wmi_win_ipaddress",$_SERVER['REMOTE_ADDR']);
				}
				if(!empty($sbc_version)) {
					$this->Account->saveField("wmi_install_status",$sbc_version);
				}
				if(!empty($sbc_version)) {
					$this->Account->saveField("sbc_version",$sbc_version);
				}
			}
		}
		return ;
	}
	
	function sbminfo(){
		$this->layout = "debug";
	}
	
	
	/**
	 * システムバックアップ
	 * バックアップ設定、ユーザ設定、グループの変更時に自動（７世代）
	 * それぞれ上記の設定が変更されたときに作成
	 * 実行 file_get_contents("http://SBS_LOCAL_ADDRESS/api/systembackup");
	 */
	function systembackup($type=""){
		$res = $this->_systembackup($type);
		if($res) {
			echo 0;
		} else {
			echo 1;
		}
		exit;
	}
	
	function alert_from_idc(){
		$cln = new Sanitize;
		
		$max = addslashes(@$_GET['max']);
		$per = addslashes(@$_GET['per']);
		
		if(empty($max) or empty($per)){
			echo "1 パラメータ不足です";
			exit;
		}
		
		$data['message'] = "[容量警告:データセンタ]\r\n"
		."データセンタの空き領域が{$per}%以下になりました。\r\n"
		."データセンタの契約容量は{$max}GBです。\r\n";
		$data['type'] = "admin";
		$data['from'] = "データセンタ";
		$res = $this->reg_information($data,false);
		echo $res;
		exit;
	}
	
	function alert_to_admin($type){
		$cln = new Sanitize;
		
		switch($type){
			case "1":
				$max = addslashes(@$_GET['max']);
				$per = addslashes(@$_GET['per']);
				
				if(empty($max) or empty($per)){
					echo "1 パラメータ不足です";
					exit;
				}
				
				$data['message'] = "[容量警告:バックアップサーバ]\r\n"
				."D:ドライブの空き領域が{$per}%以下になりました。\r\n"
				."D:ドライブの大きさは{$max}GBです。 \r\n";
				
			break;
			
			case "2":
				$data['message'] = "[接続エラー]\r\nデータセンタへの接続ができなくなっています。\r\n";
			break;
			
			case "3":
				$data['message'] = "[接続エラーの回復]\r\nデータセンタへの接続が回復しました。\r\n";
			break;
		}
		$data['type'] = "admin";
		$data['from'] = "バックアップサーバ";
		
		$res = $this->reg_information($data,false);
		echo $res;
		exit;
	}
	
	function index($data = null,$output = true){
		$this->reg_information($data,$output);
		exit;
	}
	
	/**
	 * お知らせ登録API
	 * @type  (text) 'admin'or'account'or'group',
	 * @to (text) ACCOUNT_ID or GROUP_ID type=adminの場合は省略
	 * @message (text)
	 * @from (text)メッセージの頭に追記される
	 */
	
	function reg_information($data = null,$output = true){
		$cln = new Sanitize;
		$from = "Secure Back Managerからのお知らせです";
		$error_date = "";
		$error_no = "";
		
		//初期設定
		$group_id = null;
		$account_id = null;
		
		if(!empty($data)){
			$_GET = $data;
		}
		
		if(!empty($_GET['type'])){
			$type = addslashes($_GET['type']);
		}
		
		if(!empty($_GET['from'])){
			$from = addslashes($_GET['from']);
		}
		
		if(!empty($_GET['to'])){
			$to = addslashes($_GET['to']);
		}
		
		if(!empty($_GET['error_no'])){
			$error_no = addslashes($_GET['error_no']);
		}
		
		if(!empty($_GET['error_date'])){
			$error_date = addslashes($_GET['error_date']);
		}
		
		if(!empty($_GET['message'])){
			$message = addslashes($_GET['message']);
		}
		
		//toよりswitch文で送り先設定 cond文作成
		switch($type){
			case "admin":
				$cond = "";
			break;
			
			case "account":
				if(!empty($to)){
					$cond = "Account.ACCOUNT_ID = '{$to}'";
				}
			break;
			
			case "group":
				if(!empty($to)){
					$cond = "Groupattribute.GROUP_ID = '{$to}'";
				}
			break;
		}
		//該当account検索 
		if(!empty($cond)){
			$res = $this->Account->findAll($cond,"*");
		}
		if($type == "admin"){
			$res[0]['Account']['ACCOUNT_ID'] = "0";
		}
		//該当accountからinformationに登録
		$i = 0;
		if(!empty($res)){
			foreach($res as $w){
				$this->Information->id = null;
				$info['Information']['ACCOUNT_ID'] = $w['Account']['ACCOUNT_ID'];
				$info['Information']['information'] = $message;
				$info['Information']['subject'] = $from;
				$info['Information']['error_no'] = $error_no;
				$info['Information']['error_date'] = $error_date;
				$save = $this->Information->save($info);
				$i++;
			}
			$count = count($res);
			$msg[] =  $count."件の該当者にお知らせを登録しました";
		}else{
			$msg[] =  "お知らせの登録に失敗しました。";
		}
		
		if(!empty($msg) && $output === true){
			$ret = implode($msg,"");
		}elseif($output === false){
			if($save){
				$ret = "0";
			}else{
				$ret = "1 データベースに登録出来ませんでした";
			}
		}else{
			return ;
		}
		if($output === false){
			return $ret;
		}else{
			echo $ret;
		}
		exit;
	}
	
	
	/**
	 * 申請テスト
	 */
	
	function apptest(){
		$this->layout = "default";
	}
	
	/**
	 * LOG_KIND 1:web 2:sbs 3:getconf 4:getconfdate
	 */
	
	function databackup($mode = null){
		//バックアップするファイルを抽出
		$file = file(BACKUPTEXT);
		$date = date("Ymd");
		if(!empty($file)){
			//テンポラリ作成
			$budir = APP."tmp".DS."backup";
			if(!file_exists($budir)){
				mkdir($budir);
			}
			$dirname = $budir.DS."SBM_BACK_UP";
			$sbrdir = $dirname.DS."SBRService_cfg";
			
			$mysqldir = $dirname.DS."mysql";
			if(!file_exists($dirname)){
				mkdir($dirname);
			}
			$d = opendir($budir);
			$r = readdir($d);
			$min = date("Ymd");
			while($r = readdir($d)){
				if(ereg("SBMBackup_([0-9-]*)\.zip",$r,$match)){
					$count[]['date'] = $match[1];
					if($min >= $match[1]){
						$min =$match[1];
					}
				}
			}
			
			if(count($count) > 7){
				unlink($budir.DS."SBMBackup_{$min}.zip");
			}
			
			$file[] = APP."config".DS."config.inc,\config.inc";
			while(list($n,$v) = each($file)){
				$f = null;
				$v = trim($v);
				if(!empty($v)){
					//テンポラリにコピーしていく
					if(!file_exists($sbrdir)){
						mkdir($sbrdir);
					}
					if(!file_exists($mysqldir)){
						mkdir($mysqldir);
					}
					$f = explode(",",$v);
					if(count($f) == 2){
						copy($f[0],$dirname.$f[1]);
					}
				}
			}
			//chdir($dirname);
   	  $cmd = sprintf('%s\zip -1 -r %s.zip '.$dirname.DS.'*', DIR_CMD_COMMON, $budir.DS."SBMBackup_".$date);
			list($retval, $output) = $this->_exec($cmd,false);
			if($mode != 1){
				session_cache_limiter('public');
				header("Content-disposition: attachment; filename=SBMBackup_".$date.".zip");
				header("Content-type: application/octet-stream; name=SBMBackup_".$date.".zip");
				
				readfile(APP."tmp".DS."backup".DS."SBMBackup_".$date.".zip");
			}
		}
		exit;
	}
	
  function _exec($cmd,$res_output = true) {
    return $this->_exec_sbw($cmd,$res_output);
  }
  
  
	/**
	 * mysqlのチェック他
	 */
	function chkmysql(){
		$retval = null;
		$res2 = false;
		
		//mysql接続チェック
		$query = "select * from admin";
		$res = $this->Sbblog->query($query);
		if(!empty($res)){
			$this->set("res",$res);
		}
		
		//dirquota チェック
		$chkdirquota = exec("dirquota",$output,$retval);
		if(empty($output[0])){
			$res2 = false;
		}else{
			$res2 = true;
		}
		$this->set("res2",$res2);
	}
	
	/**
	 *  config.inc更新API
	 */
	function updateconfiginc(){
		$idc = IDC_API_ADDRESS;
		$url = $idc."api/createconfig/".UID."/";
		if(!ereg("^(http|HTTP):",$url)) $url = "http://".$url;
		$config = file_get_contents($url);
		$this->log("updateconfiginc url -> {$url}");
		
		if(!empty($config)){
			$file = APP.DS."config".DS."config.inc";
			$fp = fopen($file,"w");
			$res = fwrite($fp,$config);
			fclose($fp);
			if(!empty($res)){
				echo "true";
			}else{
				echo "false";
			}
		}else{
			echo "false";
		}
		exit;
	}
	
	/**
	 *  コンフィグ取得API attrincはgetconf時に arrtexcに変換
	 */
	function getconf($id = NULL) {
		Configure::write('debug', 0);
		$id = sprintf('%03d', $id);
		$ua = $_SERVER['HTTP_USER_AGENT'];
		$sbc_version = 0;
		$yomikae = false;
		if(eregi('Secure Back Client Version ([0-9.]+)', $ua, $match)) {
			$sbc_version = $match[1];
		}
		$this->set(compact('yomikae'));

		try {
			$this->layout = "uni_api";
			if(empty($id)){
				throw new Exception('empty id', 3);
			}
			$exc_file = '';
			$exc = array();
			$clean = new Sanitize;
			$id = addslashes($id);
			$data = $this->Account->find("Account.ACCOUNT_ID = '{$id}'");

			if(empty($data)){
				throw new Exception('empty data', 3);
			}
			
			$this->_heartbeat($id,"api/getconf");
			
			if(!empty($data['Account']['SBC_EXCLUDE_FILE'])){
				$exc_file = stripslashes($data['Account']['SBC_EXCLUDE_FILE']);
			}
			$this->set("account",$data);

			//$sbbconf = $this->Sbbconf->findAll("Sbbconf.ACCOUNT_ID = '{$id}' and Sbbconf.CONF_TERMINAL_LAN = '1'",null,"Sbbconf.CONF_ENTRY_NUM asc");
			$settingNums = $this->BackupSetting->getEntryNums();
			$sbbconf = $this->Sbbconf->find('all', array(
				'conditions' => array(
					'Sbbconf.ACCOUNT_ID' => $id,
					'Sbbconf.CONF_TERMINAL_LAN' => 1,
					'Sbbconf.CONF_ENTRY_NUM' => $settingNums,
				),
				'order' => array('Sbbconf.CONF_ENTRY_NUM' => 'asc', 'Sbbconf.id' => 'desc')
			));
			$schedule = $this->Schedule->findAll("Schedule.ACCOUNT_ID = '{$id}'");

			//設定取得
			list($confs,$res,$accountSetting) = $this->Api->getConf($data,$sbbconf,$schedule);
			$this->set(compact('accountSetting'));
			$this->set("pid",sprintf("%03d",$id));
			$this->set("pw",$data['Account']['ACCOUNT_PASSWORD']);
			
			//WABTE BLOCK SIZE
			if(file_exists(APP."config".DS."wabteblocksize.txt")){
				$blocksizetxt = file(APP."config".DS."wabteblocksize.txt");
				if(!defined("WABTEBLOCKSIZE") && mb_ereg("^[0-9]+$",$blocksizetxt[0])){
					define("WABTEBLOCKSIZE",$blocksizetxt[0]);
				}
			}
			//ATTRINCだが実際はATTREXEC
			$attrexc = 6;
			if(!empty($data['Account']['ATTRINC_2'])){
				$attrexc -= 2;
			}
			
			if(!empty($data['Account']['ATTRINC_4'])){
				$attrexc -= 4;
			}
			$this->set("attrexc",$attrexc);
			$this->set("exc",@$exc_file);
			if(!empty($confs)){
				//高度な設定で設定した除外ファイルを、バックアップ元によって処理する
				foreach($confs as $key => $confdata){
					switch($confdata['entry_num']){
						case '9': //firefox
						case '10': //thunderbird
							//*.dbは必要なファイルなのではずす
							$exc_exp = explode(';',$exc_file);
							if(!empty($exc_exp)){
								foreach($exc_exp as $exp_n => $exp_v){
									if($exp_v == '*.db'){
										
									}else{
										$arr_exp[$exp_n] = $exp_v;
									}
								}
							}
							if(!empty($arr_exp)){
								$exc[$confdata['entry_num']] = implode($arr_exp,';');
							}
						break;
						default: //基本的には統一
							$exc[$confdata['entry_num']] = @$exc_file;
						break;
					}
				}
			}
			
			$this->set("exc",$exc);
			
			if(!empty($confs) && $res == 0){
				$this->set("sbbconf",$confs);
				$count = count($confs);
				$this->set("count",$count);
				//$this->Certificationlog->_savelog($id,1,"3");
			}else{
				throw new Exception('empty conf', $res);
			}
			$filename = APP."tmp".DS."confs".DS."conf_".$id.time().".txt";
			$confname = APP."tmp".DS."confs".DS."sbcconf_".$id.time().".txt";
			$this->set("filename",$filename);
			$this->render();
		} catch (Exception $e) {
			Configure::write('Cache.disable', true);
			$resCode = $e->getCode();
			$msg = $e->getMessage();
			$this->set(compact('resCode', 'msg'));
			$this->render('getconf_error');
		}
	}
	
	/**
	 * 申請用API
	 */
	
	function app_login(){
		$clean = new Sanitize;
		if(empty($id) && empty($_GET['id'])){
			echo "1";
			exit;
		}
		if(!empty($_GET['id'])){
			$_GET['id'] = htmlspecialchars($_GET['id']);
			$login_id = addslashes($_GET['id']);
		}else{
			echo "1";
			exit;
		}
		$mode = "account_login_id";
		$data = $this->Account->find("Account.ACCOUNT_LOGIN_ID = '{$login_id}'");
		$id = $data['Account']['ACCOUNT_ID'];
		
		$res = $this->Api->login($data,null,"account_login_id");
		
		if($res['ret'] == 0){
			$this->Account->id = $id;
			$conf = $this->requestAction("/api/getconf/".$id,array("return"));
			exit;
		}else{
			echo $res['ret'];
		}
		exit;
	}
	
	function _api_disp($txt){
		if(Configure::read('debug') == 2) {
			header("Content-type: text/html;charset=UTF-8;");
			var_dump($txt);exit;
		}
		$this->set("txt",$txt);
		$this->layout = "uni_api";
		$this->render("_api_disp");
		//var_dump($GLOBALS['processTime']);
		//var_dump(sprintf('%.2f', microtime() - PROCESS_START_TIME));
	}

	function _loadData($accountID) {
		return $this->Account->find('first',array(
			'conditions' => array(
				"Account.ACCOUNT_ID = '{$accountID}'"
			),
			'recursive' => -1,
			'fields' => array(
				'Account.ACCOUNT_ID', 'Account.ACCOUNT_LOGIN_ID',
				'Account.ACCOUNT_SBBTIME_FIRST',
				'Account.ACCOUNT_PASSWORD',
				'Account.ACCOUNT_BANDWIDTH',
				'Account.ACCOUNT_SBC_MODE',
				'Account.SBC_APPLICATION',
				'Account.ACCOUNT_CHANGEPW',
				'Account.userdataupdate',
				'ACCOUNT_PW_DATE',
				'ACCOUNT_CHANGEPW',
				'ACCOUNT_PW_LIMIT',
				'wmi_win_ipaddress'
			)
		));
	}
	function _loadDataByLoginID($loginID) {
		return $this->Account->find('first',array(
			'conditions' => array(
				"Account.ACCOUNT_LOGIN_ID = '{$loginID}'"
			),
			'recursive' => -1,
			'fields' => array(
				'Account.ACCOUNT_ID', 'Account.ACCOUNT_LOGIN_ID',
				'Account.ACCOUNT_SBBTIME_FIRST',
				'Account.ACCOUNT_PASSWORD',
				'Account.ACCOUNT_BANDWIDTH',
				'Account.ACCOUNT_SBC_MODE',
				'Account.SBC_APPLICATION',
				'Account.ACCOUNT_CHANGEPW',
				'Account.userdataupdate',
				'ACCOUNT_PW_DATE',
				'ACCOUNT_PW_LIMIT'
			)
		));
	}

	function cryptTest() {
		Configure::write('debug', 0);
		$this->autoRender = false;
		$file = TMP . 'plane';
		$cryptedfile = TMP . 'a0cb622da2f6c8a57674f7a02fcdbfe1.002';
		$txt = implode(file($file), '');
		$dest = implode(file($cryptedfile), '');
		$keystring = '002';
		$crypted = $this->_textCrypt($txt, $keystring);
		debug('Crypted : ' . $crypted);
		$decrypted = $this->_textDecrypt($crypted, $keystring);
		debug('Decrypted : ' . $decrypted);
		$fp = fopen(TMP . 'crypt-test.002', 'wb');
		fwrite($fp, $crypted);
		fclose($fp);
		debug('Dest: ' . $dest);
		$decrypted = $this->_textDecrypt($dest, $keystring);
		debug('DestDecrypted : ' . $decrypted);

	}
	
	/**
	 *  認証API 
	 */
	function login($id = null, $client = NULL) {
		//ヘッダチェック
		if(!mb_ereg("unicode",$_SERVER['HTTP_USER_AGENT'])){
			$encode = "SJIS";
		}else{
			$encode = "UTF-8";
		}

		/* debug {{ */
			//Configure::write('debug', 2);
			//$encode = "UTF-8";
		/* debug }} */
		
		if(empty($id) && empty($_GET['id'])){
			$this->Certificationlog->_savelog($id,1,"2");
			return $this->_api_disp("1");
		}
		$clean = new Sanitize;
		$id = addslashes($id);
		if(!empty($id)){
			$mode = "account_id";
			$data = $this->_loadData($id);
		}else{
			if(!empty($_GET['id'])){
				if($encode == "SJIS"){
					$_GET['id'] = mb_convert_encoding($_GET['id'],"UTF-8","SJIS-win");
				}
				$_GET['id'] = addslashes($_GET['id']);
				$login_id = $_GET['id'];
			}else{
				return $this->_api_disp("1");
			}
			$mode = "account_login_id";
			$data = $this->_loadDataByLoginID($login_id);
			//var_dump($data, $login_id);
			$id = $data['Account']['ACCOUNT_ID'];
		}
		$res = $this->Api->login($data,null,$mode);
		
		if($res['ret'] == 0){

			$params = str_replace('/api/login/', '', $_SERVER['REQUEST_URI']);
			$this->cacheFile = PATH_PG_BASE . 'gss' . DS . 'login' . DS . md5($params) . '.' . sprintf('%03d', $res['Account']['ACCOUNT_ID']);

			$this->_heartbeat($id,"api/login");
			$this->Account->id = $id;
			if($client == 'sbcs') {
				$this->SbcStatusHistory->saveLogin($id);
			}
    		
			//使用中のアカウントのチェック
			$cond[] = "ACCOUNT_LOGIN_ID != ''";
			$account_count = $this->Account->findCount($cond);
			if($account_count > PC_NUM){
				return $this->_api_disp("1");
			}
			$macAddress = NULL;
			$macAddress = $this->Cmd->getMacAddress($_SERVER['REMOTE_ADDR']);
			$regex_ip = "/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/";

			if(preg_match('/^Secure Back Client.*$/', $_SERVER['HTTP_USER_AGENT'])) {
				if(empty($res['Account']['wmi_win_ipaddress']) || preg_match($regex_ip, $res['Account']['wmi_win_ipaddress'])) {
					$this->Account->SaveField("wmi_win_ipaddress",$_SERVER['REMOTE_ADDR']);
				}
				$this->Account->SaveField("ACCOUNT_SBBADDRESS",$_SERVER['REMOTE_ADDR']);
				$this->Account->SaveField("ACCOUNT_MACADDRESS",$macAddress);
				$this->Account->SaveField("ACCOUNT_SBBTIME",date("Y-m-d H:i:s"));
				$this->Account->SaveField("user_agent",$_SERVER['HTTP_USER_AGENT']);

				if(empty($res['Account']['ACCOUNT_SBBTIME_FIRST']) or $res['Account']['ACCOUNT_SBBTIME_FIRST'] == "0000-00-00 00:00:00"){
					$res_sbbtime = $this->Account->SaveField("ACCOUNT_SBBTIME_FIRST",date("Y-m-d H:i:s"));
				}
			} else {
			}
			//鍵ではなくユーザ
			$genkey = $id;
			if(!empty($res['Account']['ACCOUNT_BANDWIDTH'])){
				$res['Account']['ACCOUNT_BANDWIDTH'] = $res['Account']['ACCOUNT_BANDWIDTH'];
			}
			if(!empty($res['Account']['ACCOUNT_ID'])){
				$sbbconf_exists = $this->Sbbconf->findCount("ACCOUNT_ID = '{$res['Account']['ACCOUNT_ID']}' and Sbbconf.CONF_TERMINAL_LAN = '1'");
				if(empty($sbbconf_exists)) {
					$this->_api_disp("4");
				}
			}
			if(!empty($res['Account']['SBC_APPLICATION']) && $res['Account']['SBC_APPLICATION'] == "9"){
				$res['Account']['SBC_APPLICATION'] = "1";
			}
			define("LOG_UPLOAD_DIR",PATH_LOG.sprintf("%03d",$id));
			if($genkey){
				if(!empty($res['Account']['ACCOUNT_SBC_MODE'])){
					if($res['Account']['ACCOUNT_SBC_MODE'] == 2 or $res['Account']['ACCOUNT_SBC_MODE'] == 4){
						$stealthmode = 1;
					}else{
						$stealthmode = 0;
					}
					if($res['Account']['ACCOUNT_SBC_MODE'] == 3 or $res['Account']['ACCOUNT_SBC_MODE'] == 4){
						$servicemode = 1;
					}else{
						$servicemode = 0;
					}
				}
				$md5 = md5((SBS_ID.sprintf("%03d",$id)));
				$temporaryPw = substr($md5,-16);
				
				# MS09

				$txt = $res['ret'].",".$res['Account']['ACCOUNT_BANDWIDTH'].",".SBS_ID.",26706\r\n".SBC_VERSION."\r\n".SBC_INSTALLER_URL."\r\n"."logpath=".LOG_UPLOAD_DIR."\r\n"."stealthmode=".$stealthmode."\r\n"."applicationmode=".$res['Account']['SBC_APPLICATION']."\r\nid=".sprintf("%03d",$res['Account']['ACCOUNT_ID'])."\r\nservicemode=".$servicemode."\r\ntemporarypw=".$temporaryPw;
				if($res['Account']['ACCOUNT_CHANGEPW'] == 1){
					$txt .= "\r\npasswordlimit=".$res['Account']['pw_limit_date'];
				}
				$remoteSettings = $this->RemoteSettingsAccount->find('first',array(
					'conditions' => array('RemoteSettingsAccount.account_id' => $res['Account']['ACCOUNT_ID']),
					'fields' => array('RemoteSetting.*')
				));
				$admin_domain_host = '';
				$admin_username = '';
				$admin_password = '';
				if(!empty($remoteSettings['RemoteSetting'])) {
					$remote = $remoteSettings['RemoteSetting'];
					$admin_domain_host = $remote['domain_host'];
					$admin_username = $remote['username'];
					$admin_password = $remote['password'];
				}
				if(!empty($admin_domain_host)) $txt .= "\r\nadmin_domain_host=". $admin_domain_host;
				if(!empty($admin_username)) $txt .= "\r\nadmin_username=". $admin_username;
				if(!empty($admin_password)) $txt .= "\r\nadmin_password=". $admin_password;
				$this->_createLoginCache($this->cacheFile, $txt, sprintf('%03d', $id));
				return $this->_api_disp($txt);
				
				# MS07
			}else{
				return $this->_api_disp("cannot generate key");
			}
			$this->Certificationlog->_savelog($id,$res['ret'],"2");
		}else{
			echo $res['ret'];
			$this->Certificationlog->_savelog($id,$res['ret'],"2");
		}
		@mysql_free_result();
		@mysql_close();
		exit;
	}
	
	/**
	 *  最終コンフィグ取得時間 
	 */
	function getconfdate($id) {
		$clean = new Sanitize;
		$id = addslashes($id);
		$log_date = "";
		$log = $this->Account->find('first', array(
			'conditions' => array("Account.ACCOUNT_ID = '{$id}'"),
			'fields' => array('Account.CONF_UPDATE'),
			'recursive' => -1
		));
		if(!empty($log) && !empty($log['Account']['CONF_UPDATE'])){
			$log_date = date("YmdHis",strtotime($log['Account']['CONF_UPDATE']));
		}else{
			$log_date = date("YmdHis");
			$this->Account->saveConfDate($id);
		}
		$data = $this->_loadData($id);
		$res = $this->Api->login($data);
		
		if($res['ret'] == 0){
				$sbbconf_exists = $this->Sbbconf->findCount("ACCOUNT_ID = '{$id}' and Sbbconf.CONF_TERMINAL_LAN = '1'");
				if(empty($sbbconf_exists)) {
					echo "4";
					exit;
				}
			//出力する
			$this->_heartbeat($id,"api/getconfdate");
			echo "0,",$log_date.",".date("YmdHis",strtotime($data['Account']['userdataupdate'])).",".SBC_VERSION;
			
		}else{
			echo $res['ret'];
		}
		
			//toDo:最終コンフィグ受け渡し時間を記録
		//$this->Certificationlog->_savelog($id,$res['ret'],"4");
		exit;
	}
	
	/**
	 * 
	 */
	 
	function _auth($account_id,$pw = null){
		$res = null;
		
		//ini sanitize
		$clean = new Sanitize;
		$pid = addslashes($account_id);
		//data
		$data = $this->Account->find("Account.ACCOUNT_ID = '{$pid}'");
		$res = $this->Api->login($data,$pw);
		return $res;
	}
	
	/**
	 * SBNへのお知らせ
	 * 未ログイン警告
	 * 未転送警告
	 * 未転送警告　いつの日の分まで送ったか記録しておく
	 */
	function sbn($account_id){

		set_time_limit(0);
		Configure::write('debug', 0);
		header("Content-type: text/plain;charset=UTF-8");

		$this->layout = "uni_api";
		$clean = new Sanitize;
		$account_id = addslashes($account_id);
		$warn = NULL;
		$sbmconf = $this->Sbmconf->findById(1);
		//SBNからのアクセス
		
		$admin = $this->Admin->find();
		if($admin['Admin']['ADMIN_ID'] == $account_id){
			$mode = "sbn";
			$lastlogin = $admin['Admin']['ADMIN_LOGIN'];
			if(!empty($lastlogin)){
				$lastlogintime = strtotime($lastlogin);
			}
			if(!empty($lastlogin) && ($lastlogintime > strtotime('2009-05-01'))){
				$this->set("lastlogin",date("Y-m-d",strtotime($lastlogin)));
			}else{
				$date = date("Y-m-d H:i:s");
				$this->Admin->query("update admin set ADMIN_LOGIN = '".$date."' where ADMIN_ID = '{$admin['Admin']['ADMIN_ID']}'");
				$this->set("lastlogin",$date);
			}
			if(empty($_GET['pw'])){
				echo "3";
				exit;
			}
			
			$pw = addslashes($_GET['pw']);
			
			
			
			if($pw == $admin['Admin']['ADMIN_PASS']){
				$res['ret'] = 0;
				$this->Certificationlog->_savelog("0","1","3");
			}else{
				echo "3";
				exit;
			}
			
		}else{
			echo "3";
			exit;
		}
		
		$this->set("mode",$mode);
		$this->set("res",$res['ret']);
		
		//failed
		if($res['ret'] === null || $res['ret'] != 0){
			return $this->render();
		}
		
		//true /////////////////////////////////////////////////////////////////////////
		
		//転送できないファイルがなかったか
		//最後に
		if(!empty($sbmconf)){
			$notransfer_date = $sbmconf['Sbmconf']['notransfer_date'];
			//$notransfer_date = '2012-09-01';
		}
		$notransfer_chk = false;
		$cmd = $this->Sbblog->setNoToransferCmd($notransfer_date);
		list($res,$output) = $this->_exec($cmd,true);
		if(!empty($output)){
			list($notransfer_chk, $accounts) = $this->Sbblog->searchNoToransfer($notransfer_date,$output);
		}
		
		$account_list = '';
		if(!empty($notransfer_chk)){
			$notransfer_msg = '%sに転送できなかったファイルの一覧が更新されました。'.PHP_EOL.'Secure Back Maneger のログ管理画面より、未転送一覧を参照してください%s';
			$save['type'] = "admin";
			$save['from'] = "Secure Back Managerからのお知らせ";
			$save['error_date'] = date("Y-m-d");
			if(!empty($accounts)) {
				$account_list = PHP_EOL;
				foreach($accounts as $index => $account_id) {
					$this->Account->id = (int)$account_id;
					$account = $this->Account->read(array('ACCOUNT_LOGIN_ID'), $account_id);
					$account_list .= sprintf('%03d : %s', $account_id, $account['Account']['ACCOUNT_LOGIN_ID']). PHP_EOL;
				}
			}
			asort($notransfer_chk);
			foreach($notransfer_chk as $key => $value){
				$save['message'] = sprintf($notransfer_msg,$value, $account_list);
				$save['error_no'] = "3";
				$this->reg_information($save,false);
			}
			$this->Sbmconf->id = 1;
			$this->Sbmconf->saveField('notransfer_date',date('Y-m-d',$key));
		}
		
		//本日無ログインチェックを行っているかどうか
		$nologin_chk = false;
		$this->Information->unbindModel(array("belongsTo" => array("Account")));
		
		$w = $this->Information->find("Information.error_date = '".date("Y-m-d")."' and Information.error_no = 1");
		if(!empty($w)){
			$nologin_chk = true;
		}
		
		$w2 = $this->Information->find("Information.error_date = '".date("Y-m-d")."' and Information.error_no = 2");
		if(!empty($w)){
			$nologin_chk = true;
		}
		
		$nologin_chk = false;
		
		if($nologin_chk === false){
			//無ログインチェック
			
			$limit = SBC_NO_LOGIN_TERM;
			$sql = "select ".
			"ACCOUNT_ID,ACCOUNT_LOGIN_ID,heartbeat,ADDDATE(heartbeat,INTERVAL {$limit} DAY) as chkdate ".
			"from account as Account ".
			"where ACCOUNT_LOGIN_ID != '' and ACCOUNT_LOGIN_ID is not NULL and ACCOUNT_LOGIN_ID < 10 order by ACCOUNT_ID";
			$accounts = $this->Account->query($sql);
			$now = time();
			
			foreach($accounts as $a){
				if(empty($a['Account']['heartbeat']) or $a['Account']['heartbeat'] == "0000-00-00 00:00:00"){
					if(empty($w)){
						$warn[$a['Account']['ACCOUNT_ID']]['status'] = "nosbbtime";
						$warn[$a['Account']['ACCOUNT_ID']]['name'] = $a['Account']['ACCOUNT_LOGIN_ID'];
						$warn[$a['Account']['ACCOUNT_ID']]['time'] = $a['Account']['heartbeat'];
					}
				}else{
					//echo strtotime(date("Y-m-d 23:59:59")) .">".strtotime(date("Y-m-d 23:59:59",strtotime($a[0]['chkdate'])))."\r\n";
					//exit;
					if(empty($w2)){
						if(strtotime(date("Y-m-d 00:00:00")) > strtotime(date("Y-m-d 23:59:59",strtotime($a[0]['chkdate']))) ){
							$warn[$a['Account']['ACCOUNT_ID']]['status'] = "nologin";
							$warn[$a['Account']['ACCOUNT_ID']]['name'] = $a['Account']['ACCOUNT_LOGIN_ID'];
							$warn[$a['Account']['ACCOUNT_ID']]['time'] = $a['Account']['heartbeat'];
						}
					}
				}
			}
			
			//warnをお知らせに登録
			if(!empty($warn)){
				//$org = ini_get("magic_quotes_gpc");
				//ini_set("magic_quotes_gpc","off");
				$save['type'] = "admin";
				$save['from'] = "Secure Back Managerからのお知らせ";
				$save['error_date'] = date("Y-m-d");
				$messages_nologin[] = '下記のユーザは、Secure Back Clientを'.SBC_NO_LOGIN_TERM.'日以上起動していません。';
				$messages_nosbbtime[] = '下記のユーザは、まだSecure Back Clientを起動していません。';
				
				foreach($warn as $pid => $wa){
					if($wa['status'] == "nosbbtime"){
						$messages_nosbbtime[] = sprintf("%03d",$pid).':'.$wa['name'].'';
					}elseif($wa['status'] == "nologin"){
						$messages_nologin[] = sprintf("%03d",$pid).':'.$wa['name'].' (最終ログイン日時:'.$wa['time'].')';
					}
				}
				
				if(!empty($save)){
					if(count($messages_nologin)>1){
						$save['message'] = implode($messages_nologin, '\n');
						$save['error_no'] = "2";
						$this->reg_information($save,false);
					}
					
					if(count($messages_nosbbtime)>1){
						$save['message'] = implode($messages_nosbbtime, '\n');
						$save['error_no'] = "1";
						$this->reg_information($save,false);
					}
					//exit;
				}
				
				//ini_set("magic_quotes_gpc",$org);
			}
		}
		////////////////////////////////////////////////////////////////////////////////////////////////
		
		//process
		$clean = new Sanitize;
		$pid = 0;
		$data = $this->Information->findAll("Information.ACCOUNT_ID = '".$pid."' and Information.sendflg = 0");
		//配信フラグ
		foreach($data as $w){
			$this->Information->id = $data['Information']['id'];
			$w['Information']['sendflg'] = 1;
			$w['Information']['modified'] = date("Y-m-d H:i:s");
			$this->Information->set($w);
			$this->Information->save($w);
		}
		$this->set("data",$data);
		$this->render();
	}
	//>
	/**
	 * お知らせ取得
	 */
	function getinfo($account_id){
		$this->layout = "uni_api";
		$this->autoRender = false;
		$clean = new Sanitize;
		$account_id = addslashes($account_id);
		
		//SBNからのアクセス
		
		$admin = $this->Admin->find();
		if($admin['Admin']['ADMIN_ID'] == $account_id){
			$mode = "sbn";
			$lastlogin = $admin['Admin']['ADMIN_LOGIN'];
			
			if(!empty($lastlogin) && $lastlogin != "0000-00-00 00:00:00"){
				$this->set("lastlogin",date("Y-m-d",strtotime($lastlogin)));
			}else{
				$date = date("Y-m-d H:i:s");
				$this->Admin->query("update admin set ADMIN_LOGIN = '".$date."' where ADMIN_ID = '{$admin['Admin']['ADMIN_ID']}'");
				$this->set("lastlogin",$date);
			}
			if(empty($_GET['pw'])){
				echo "3";
				return;
			}
			
			$pw = addslashes($_GET['pw']);
			
			
			
			if($pw == $admin['Admin']['ADMIN_PASS']){
				$res['ret'] = 0;
				$this->Certificationlog->_savelog("0","1","3");
			}else{
				echo "3";
				return;
			}
			
		}else{
			$mode = "sbc";
			//res
			$res = $this->_auth($account_id);
		}
		$this->set("mode",$mode);
		$this->set("res",$res['ret']);
		
		//failed
		if($res['ret'] === null || $res['ret'] != 0){
			return $this->render('getinfo');
		}
		
		//process
		$clean = new Sanitize;
		$pid = addslashes($account_id);
		if($mode == "sbn"){
			$pid = 0;
		}
		$this->_heartbeat($pid,"api/getinfo");
		$data = $this->Information->findAll("Information.ACCOUNT_ID = '".$pid."' and Information.sendflg = 0");
		
		//配信フラグ
		foreach($data as $w){
			$w['Information']['sendflg'] = 1;
			$w['Information']['modified'] = date("Y-m-d H:i:s");
			$this->Information->save($w);
		}
		
		$this->set("data",$data);
		$this->render();
	}
	
	function getquotalist_old(){
		header("content-type: text/plain");
		$res = $this->Account->find('all', array(
			'conditions' => array(
				"Account.ACCOUNT_LOGIN_ID is not NULL and Account.ACCOUNT_LOGIN_ID != ''"
			),
			'recursive' => -1,
			'fields' => array('Account.ACCOUNT_LOGIN_ID', 'Account.ACCOUNT_ID', 'Account.ACCOUNT_QUOTA')
		));
		
		if(!empty($res)){
			foreach($res as $r){
				if($r['Account']['ACCOUNT_ID'] == "9999"){
					$r['Account']['ACCOUNT_ID'] = "CRP";
				}elseif($r['Account']['ACCOUNT_ID'] == "0"){
					$r['Account']['ACCOUNT_ID'] = "000";
				}else{
					$r['Account']['ACCOUNT_ID'] = sprintf("%03d",$r['Account']['ACCOUNT_ID']);
				}
				echo $r['Account']['ACCOUNT_ID'].",".$r['Account']['ACCOUNT_QUOTA']."\r\n";
			}
		}else{
			echo "error";
			exit;
		}
		$this->_exportSizefile();
		exit;
	}
	function getquotalist(){
		header("content-type: text/plain");
		$res = $this->Account->find('all', array(
			'conditions' => array(
				"Account.ACCOUNT_LOGIN_ID is not NULL and Account.ACCOUNT_LOGIN_ID != ''"
			),
			'recursive' => -1,
			//'fields' => array('Account.ACCOUNT_LOGIN_ID', 'Account.ACCOUNT_ID', 'Account.ACCOUNT_QUOTA', 'Account.ACCOUNT_BACKUP_DRIVE')
		));
		
		if(!empty($res)){
			foreach($res as $r){
				$a = $r['Account'];
				if($a['ACCOUNT_ID'] == "9999"){
					$a['ACCOUNT_ID'] = "CRP";
				}elseif($a['ACCOUNT_ID'] == "0"){
					$a['ACCOUNT_ID'] = "000";
				}else{
					$a['ACCOUNT_ID'] = sprintf("%03d",$a['ACCOUNT_ID']);
				}
				if(isset($a['ACCOUNT_BACKUP_DRIVE'])) {
				echo $a['ACCOUNT_ID'] . "," . $a['ACCOUNT_QUOTA'] . ',' . $a['ACCOUNT_BACKUP_DRIVE'] . "\r\n";
				} else {
				echo $a['ACCOUNT_ID'] . "," . $a['ACCOUNT_QUOTA'] . ',' . DRIVE . "\r\n";
				}
			}
		}else{
			echo "error";
			exit;
		}
		$this->_exportSizefile();
		exit;
	}
	
	/**
	 * バックアップ設定の申請
	 */
	function application($account_id){
		header("Content-type:text/plain;charset=UTF-8;");
		set_time_limit(0);
		$form = @$this->params['form'];
		$this->set("formvalues",$form);
		$this->log("API:申請 ");

		/* {{ debug出力 */
			ob_start();
			var_dump($this->params['form']);
			$buffer = ob_get_contents();
			ob_end_clean();
			$fp = fopen(TMP.'application'. DS . 'application_' . $account_id . '.html', 'w');
			fputs($fp, $buffer);
			fclose($fp);
		/* }} debug出力 */

		//ini
		$this->layout = false;
		
		$clean = new Sanitize;
		$error = null;
		$account_id = addslashes($account_id);
		//res
		$res = $this->_auth($account_id,$form['pw']);
		$ret2 = "1";
		$this->set("res",$res['ret']);
		
		//failed
		if($res['ret'] === null || $res['ret'] != 0){
			return $this->render();
		}
		
		//アカウント詳細
		$account = $this->Account->find("Account.ACCOUNT_ID = '{$account_id}'");
		$pid = $account_id;
		$logs[$account_id] = "";
		$before[$account_id] = "";
		@header("Content-Type: text/html;");
		if(isset($form['message'])){
			$message['Appmessage']['ACCOUNT_ID'] = $account_id;
			$message['Appmessage']['MESSAGE'] = $form['message'];
			$this->Appmessage->save($message);
		}		
		
		$sbmconf = $this->Sbmconf->find("id = 1");
		
		$res_del = $this->Application->query("delete from applications where ACCOUNT_ID = '{$account_id}' and denied = 1");
		$res_del = $this->Application->query("delete from account_application where ACCOUNT_ID = '{$account_id}' and denied = 1");
		//system
		if(!empty($form['system'])){
				$chkArray = array("SBC_EXCLUDE_FILE","ACCOUNT_LOGOFFMODE","ATTRINC_2","ATTRINC_4","ACCOUNT_GENERATIONMODE","ACCOUNT_OLDDEL",'ACCOUNT_GENREPLICATION');
				#ini
				$this->data['AccountApplication']['ACCOUNT_ID'] = $account_id;
				$this->data['AccountApplication']['SBC_EXCLUDE_FILE'] = $account['Account']['SBC_EXCLUDE_FILE'];
				$this->data['AccountApplication']['ACCOUNT_LOGOFFMODE'] = $account['Account']['ACCOUNT_LOGOFFMODE'];
				$this->data['AccountApplication']['ATTRINC_2'] = $account['Account']['ATTRINC_2'];
				$this->data['AccountApplication']['ATTRINC_4'] = $account['Account']['ATTRINC_4'];
				$this->data['AccountApplication']['ACCOUNT_GENERATIONMODE'] = $account['Account']['ACCOUNT_GENERATIONMODE'];
				$this->data['AccountApplication']['ACCOUNT_OLDDEL'] = $account['Account']['ACCOUNT_OLDDEL'];
				$this->data['AccountApplication']['ACCOUNT_GENREPLICATION'] = $account['Account']['ACCOUNT_GENREPLICATION'];
				$this->data['AccountApplication']['denied'] = "0";
				
				//値のセット
				if(isset($form['system']['exclude_file'])){
					$this->data['AccountApplication']['SBC_EXCLUDE_FILE'] = addslashes($form['system']['exclude_file']);
				}
				if(isset($form['system']['logoffmode'])){
					$this->data['AccountApplication']['ACCOUNT_LOGOFFMODE'] = $form['system']['logoffmode'];
				}
				if(isset($form['system']['attrinc2'])){
					$this->data['AccountApplication']['ATTRINC_2'] = $form['system']['attrinc2'];
				}
				if(isset($form['system']['attrinc4'])){
					$this->data['AccountApplication']['ATTRINC_4'] = $form['system']['attrinc4'];
				}
				if(isset($form['system']['samedateexc'])){
					$this->data['AccountApplication']['ACCOUNT_GENERATIONMODE'] = $form['system']['samedateexc'];
				}
				if(isset($form['system']['olddel'])){
					$this->data['AccountApplication']['ACCOUNT_OLDDEL'] = $form['system']['olddel'];
				}
				if(isset($form['system']['genolddel'])){
					$this->data['AccountApplication']['ACCOUNT_GENREPLICATION'] = $form['system']['genolddel'];
				}
				
				$current = $this->Account->find("Account.ACCOUNT_ID = '{$account_id}'");
				
				
				//もしまったく同じなら保存しない
				if(!empty($current)){
					while(list($n,$v) = each($current['Account'])){
						if(in_array($n,$chkArray)){
							if($v != $this->data['AccountApplication'][$n]){
								$save_flg = 1;
							}
						}
					}
				}
				if(!empty($sbmconf['Sbmconf']['auto_accept']) && !empty($message)){
					$logs[$account_id][] = "[Message]";
					$logs[$account_id][] = "message=\"".$message['Appmessage']['MESSAGE']."\"";
				}
				if(!empty($save_flg)){
					//承認が自動の場合
					
					if(!empty($sbmconf['Sbmconf']['auto_accept']) && $sbmconf['Sbmconf']['auto_accept'] == "1"){
						$this->data['Account'] = $this->data['AccountApplication'];
						$this->Account->save($this->data);
						$ret2 = 0;
						list($logs[$account_id],$before[$account_id]) = $this->Actionlog->setAccountApplicationLog($logs[$account_id],$before[$account_id],$account,$this->data['AccountApplication'],"a","a");
					}elseif(!empty($sbmconf['Sbmconf']['auto_accept']) && $sbmconf['Sbmconf']['auto_accept'] != "1"){
						list($logs[$account_id],$before[$account_id]) = $this->Actionlog->setAccountApplicationLog($logs[$account_id],$before[$account_id],$account,$this->data['AccountApplication'],"d","a");
					}
					//承認が手動の場合
					else{
						$this->AccountApplication->save($this->data);
						$ret2 = 0;
					}
				}
			
		}
		
		//process
		if(!empty($form['backup'])){
			while(list($n,$v) = each($form['backup'])){
				
				#ini
				$entry_num = $n;
				$backup_folder = "";
				$except_folder = "";
				$except_file = "";//ユーザごとの共通設定に
				$exclude_file = "";//個別
				$nodetect = "0";
				$schedule = "";				
				$dointerval = "";
				$doonidle = "";
				$generation = "0";
				$terminal_lan = "0";
				
				$save = NULL;
				$save_sched = null;
				#
				if(isset($v['nodetect'])){
					$nodetect = $v['nodetect'];
				}
				#
				if($nodetect == 3 && !empty($v['schedule'])){
					$schedule = $v['schedule'];
				}
				#
				if($nodetect == 1 && !empty($v['dointerval'])){
					$dointerval = $v['dointerval'];
				}
				#
				if($nodetect == 2 && !empty($v['doonidle'])){
					$doonidle = $v['doonidle'];
				}
				#MD,DT,FA,OE,WM,BK,OL,FF,TB
				if(isset($v['backup_folder'])){
					switch($n){
						case "0":
						case "1":
						case "2":
						case "3":
						case "20":
						case "25":
						case "30":
						case "40":
						case "45":
						case "9":
						case "10":
							$backup_folder = $this->Api->_returnFixedPath($n);
						break;
						
						default:
							$backup_folder = $v['backup_folder'];
					}
				}
				#世代
				if(isset($v['generation'])){
					$generation = $v['generation'];
				}
				#除外
				if(!empty($v['exclude_folder'])){
					$except_folder = $v['exclude_folder'];
				}
				if(!empty($v['exclude_file'])){
					$except_file = addslashes($v['exclude_file']);
				}
				#有効/無効
				if(isset($v['terminal_lan'])){
					$terminal_lan = $v['terminal_lan'];
				}
				
				
				reset($v);
				// {{ 設定
				if(!empty($v['type'])){
					//承認が自動の場合　
					if(!empty($sbmconf['Sbmconf']['auto_accept']) && $sbmconf['Sbmconf']['auto_accept'] == "1"){
						//自動承認
						//$this->log("AUTO_ACCEPT start----");
						//$this->log('entry_num: ' . $n);
						//$this->log('type: ' . $v['type']);
						$sbbconf = $this->Sbbconf->find("Sbbconf.ACCOUNT_ID = '{$account_id}' and CONF_ENTRY_NUM = '{$n}'");

						if($v['type'] == "d"){
							//delete
							$this->Sbbconf->query("delete from sbb_conf where ACCOUNT_ID = '{$account_id}' and CONF_ENTRY_NUM = '{$n}'");

							$this->log("AUTO_ACCEPT => type=d");

							$id = sprintf("%03d",$account_id)."_".sprintf("%03d",$n);
							$save['Sbbconf']['CONF_ENTRY_NUM'] = $n;
							$save['Sbbconf']['ACCOUNT_ID'] = $account_id;
							$save['Sbbconf']['CONF_FROM_FOLDER'] = $backup_folder;
							$save['Sbbconf']['CONF_EXCEPT_FOLDER'] = $except_folder;

							$save['Application']['CONF_EXCEPT_FILE'] = $except_file;
							$save['Sbbconf']['CONF_EXCEPT_FILE'] = $except_file;
							$save['Sbbconf']['CONF_SCHEDULE'] = $nodetect;
							$save['Sbbconf']['CONF_CYCLETIME'] = $dointerval;
							$save['Sbbconf']['CONF_IDLEWAIT'] = $doonidle;
							$save['Sbbconf']['CONF_TERMINAL_LAN'] = $terminal_lan;
							$save['Sbbconf']['CONF_SCHEDULE_TABLE'] = $schedule;
							$save['Sbbconf']['CONF_GENERATION'] = $generation;
							$app['Application'] = $save['Sbbconf'];
							$app['Application']['action'] = $v['type'];
							list($logs[$account_id],$before[$account_id]) = $this->Actionlog->setApplicationLog($logs[$account_id],$before[$account_id],$app,$sbbconf,"a");
						}else{
							if(!empty($sbbconf)){
								$this->log('!empty($sbbconf) : true');
								//update
								$reg = "update sbb_conf set CONF_FROM_FOLDER = '{$backup_folder}',
									CONF_EXCEPT_FOLDER = '{$except_folder}',
									where ACCOUNT_ID = '{$account_id}' and CONF_ENTRY_NUM = '{$n}'";
								$this->Sbbconf->query($reg);
								$this->log("AUTO_ACCEPT => ".$reg);
							}
							//insert
							$save = $data[$n];
							$save['Sbbconf']['CONF_ENTRY_NUM'] = $n;
							$save['Sbbconf']['ACCOUNT_ID'] = $account_id;
							$save['Sbbconf']['CONF_FROM_FOLDER'] = $backup_folder;
							$save['Sbbconf']['CONF_EXCEPT_FOLDER'] = $except_folder;

							$save['Application']['CONF_EXCEPT_FILE'] = $except_file;
							$save['Sbbconf']['CONF_EXCEPT_FILE'] = $except_file;
							$save['Sbbconf']['CONF_SCHEDULE'] = $nodetect;
							$save['Sbbconf']['CONF_CYCLETIME'] = $dointerval;
							$save['Sbbconf']['CONF_IDLEWAIT'] = $doonidle;
							$save['Sbbconf']['CONF_TERMINAL_LAN'] = $terminal_lan;
							$save['Sbbconf']['CONF_SCHEDULE_TABLE'] = $schedule;
							$save['Sbbconf']['CONF_GENERATION'] = $generation;
							$this->log('Sbbconf.ACCOUNT_ID : '. $account_id);
							$this->log('Sbbconf.CONF_ENTRY_NUM : '. $n);
							$sbbConfID = $this->Sbbconf->_getId($save);
							$this->Sbbconf->id = $sbbConfID;
							$save['Sbbconf']['id'] = $sbbConfID;
							$this->log('Sbbconf.id : '. $save['Sbbconf']['id'] . ',' . $this->Sbbconf->id);
							$this->Sbbconf->set($save);
							$saveRes = $this->Sbbconf->save($save);
						//	ob_end_clean();
						//	ob_start();
						//	echo 'var_dump(';
						//	var_dump($save);
						//	echo ')';
						//	$txt = ob_get_contents();
						//	ob_end_clean();
						//	$this->log($txt);
							if($saveRes) {
								$this->log(' Save:true');
							} else {
								$this->log(' Save:false');
							}
							$this->log("AUTO_ACCEPT => save: {$n}}");

							$id = sprintf("%03d",$account_id)."_".sprintf("%03d",$n);
							$app['Application'] = $save['Sbbconf'];
							$app['Application']['action'] = $v['type'];
							list($logs[$account_id],$before[$account_id]) = $this->Actionlog->setApplicationLog($logs[$account_id],$before[$account_id],$app,$sbbconf,"a");


						}

						$this->log("AUTO_ACCEPT end----");
						$ret2 = "0";

					}elseif(!empty($sbmconf['Sbmconf']['auto_accept']) && $sbmconf['Sbmconf']['auto_accept'] != "1"){
						//自動拒否
						$sbbconf = $this->Sbbconf->find("Sbbconf.ACCOUNT_ID = '{$account_id}' and CONF_ENTRY_NUM = '{$n}'");
						$save['Application']['CONF_ENTRY_NUM'] = $n;
						$save['Application']['CONF_FROM_FOLDER'] = $backup_folder;
						$save['Application']['CONF_EXCEPT_FOLDER'] = $except_folder;
						$save['Application']['CONF_EXCEPT_FILE'] = $except_file;
						$save['Application']['CONF_SCHEDULE'] = $nodetect;
						$save['Application']['CONF_CYCLETIME'] = $dointerval;
						$save['Application']['CONF_IDLEWAIT'] = $doonidle;
						$save['Application']['CONF_GENERATION'] = $generation;
						$save['Application']['SCHEDULES'] = $schedule;
						$save['Application']['ACCOUNT_ID'] = $account_id;
						$save['Application']['CONF_TERMINAL_LAN'] = $terminal_lan;
						$save['Application']['id'] = $account_id."_".$n;
						$save['Application']['action'] = $v['type'];
						list($logs[$account_id],$before[$account_id]) = $this->Actionlog->setApplicationLog($logs[$account_id],$before[$account_id],$save,$sbbconf,"r");
						$ret2 = "0";
						//自動でない場合
					}else{
						$denied = "000";
						if(!empty($sbmconf['Sbmconf']['auto_accept']) && $sbmconf['Sbmconf']['auto_accept'] == "9"){
							$denied = 1;
						}
						switch($v['type']){
						case "d"://削除
							if(!empty($data[$n])){
								$save = $data[$n];
							}else{
								$this->Application->id = null;
							}
							$this->Application->id = $account_id."_".$n;
							$save['Application']['id'] = $account_id."_".$n;
							$save['Application']['action'] = "d";
							$save['Application']['CONF_ENTRY_NUM'] = $n;
							$save['Application']['ACCOUNT_ID'] = $account_id;
							$save['Application']['CONF_FROM_FOLDER'] = "";
							$save['Application']['CONF_EXCEPT_FOLDER'] = "";
							$save['Application']['CONF_EXCEPT_FILE'] = "";
							$save['Application']['CONF_SCHEDULE'] = "";
							$save['Application']['CONF_CYCLETIME'] = "";
							$save['Application']['CONF_IDLEWAIT'] = "";
							$save['Application']['CONF_GENERATION'] = "";
							$save['Application']['CONF_TERMINAL_LAN'] = "";
							$save['Application']['SCHEDULES'] = "";
							$save['Application']['denied'] = $denied;

							if($this->Application->save($save)){
								$ret2 = "0";
							}else{
								$error[] = "ENTRY_NUM:".$save['Application']['CONF_ENTRY_NUM']."の削除に失敗";
							}
							break;

						case "a"://追加
							if(!empty($backup_folder)){

								$save['Application']['CONF_ENTRY_NUM'] = $n;
								$save['Application']['CONF_FROM_FOLDER'] = $backup_folder;
								$save['Application']['CONF_EXCEPT_FOLDER'] = $except_folder;
								$this->log($account_id." : ".$n." : ".$backup_folder);
								$save['Application']['CONF_EXCEPT_FILE'] = $except_file;
								$save['Application']['CONF_SCHEDULE'] = $nodetect;
								$save['Application']['CONF_CYCLETIME'] = $dointerval;
								$save['Application']['CONF_IDLEWAIT'] = $doonidle;
								$save['Application']['CONF_GENERATION'] = $generation;
								$save['Application']['SCHEDULES'] = $schedule;
								$save['Application']['ACCOUNT_ID'] = $account_id;
								$save['Application']['denied'] = $denied;
								$save['Application']['CONF_TERMINAL_LAN'] = $terminal_lan;
								$save['Application']['action'] = "a";
								$save['Application']['id'] = $account_id."_".$n;

								//データ追加
								if(empty($data[$n])){
									$this->Application->id = null;
								}else{
									$this->Application->id = $account_id."_".$n;
								}
								if($this->Application->save($save)){
									$ret2 = "0";
									//お知らせ
									$info['type'] = "admin";
									$info['message'] = addslashes("新しい申請が登録されました");

								}else{
									$error[] = "ENTRY_NUM:".$save['Application']['CONF_ENTRY_NUM'].":".$backup_folder."の追加/上書きに失敗";
								}
							}else{
								//テスト終了後コメントアウト 本来は無視↓
								$error[] = "ENTRY_NUM:".$n."のディレクトリが指定されていません";
							}
							break;

						default:
							break;
						}
					}
				}
				// }} 設定


			}
		}
		$admin = $this->Session->read("admin");
		if(!empty($sbmconf['Sbmconf']['auto_accept']) && !empty($logs[$account_id])){
			$write = implode($logs[$account_id],"\n");
			$current = implode($before[$account_id],"\n");
			$this->Actionlog->reg($admin['id'],$account_id,"Secure Back Manager","申請承認/拒否",$current,$write,"true");
		}
		if(!empty($error)){
			$this->log("申請エラー:".implode($error," , "));
		}
		
		//自動承認/拒否の場合は、SBCにお知らせ配信
		if(!empty($sbmconf['Sbmconf']['auto_accept'])){
			if($sbmconf['Sbmconf']['auto_accept'] == "1"){
				$sbcinfo["Information"]['information'] = '申請が全て承認されました。';
				$this->Account->saveConfDate($account_id);
			}else{
				$sbcinfo["Information"]['information'] = '申請が全て拒否されました。';
			}
			
			$sbcinfo["Information"]['ACCOUNT_ID'] = $account_id;
			$sbcinfo["Information"]['id'] = null;
			$this->Information->id = NULL;
			$this->Information->save($sbcinfo);
		}
		
		if(!empty($info)){
			$this->Information->id = NULL;
			//$info['message'] = addslashes($info['message']);
			$this->reg_information($info,false);
		}
		$this->_exportSizefile();
		$this->Schedules->exportPowerConfig($this->Schedules->setPowerConfig());
		$this->set("ret2",$ret2);
		$this->render();
	}
	
	function powerConfigExport() {
		Configure::write('debug', 0);
		//power
		$accounts = $this->Schedules->setPowerConfig();
		$res = $this->Schedules->exportPowerConfig($accounts);
		exit;
	}
	
	
	/**
	 * 現在のバックアップ設定取得
	 * w:承認待ち a:承認済み r:承認拒否
	 */
	function getcurrent($account_id,$type = null){
		$this->layout = "uni_api";

		//バックアップ元(初期設定)をコンポーネントから取得
		$regularBackup = $this->BackupSetting->getRegularBackup();
		$optionalBackup = $this->BackupSetting->getOptionalBackup();
		$entryNums = $this->BackupSetting->getEntryNums();
		$this->set(compact('entryNums'));
		//res
		$res = $this->_auth($account_id);
		$this->set("res",$res['ret']);
		
		//failed
		if($res['ret'] === null || $res['ret'] != 0){
			$this->render();
		}
		if(!empty($account_id)){
			$sbbconf_exists = $this->Sbbconf->findCount("ACCOUNT_ID = '{$account_id}'");
			if(empty($sbbconf_exists)) {
				echo "4";
				exit;
			}
		}
		/* 現在の設定を取得 */
		//config
		$id = $res['Account']['ACCOUNT_ID'];
		$this->_heartbeat($id,"api/getcurrent");
		
		//申請の取得
		$apps = $this->Application->findAll("Application.ACCOUNT_ID = '{$id}' and CONF_ENTRY_NUM != '-1'","*","CONF_ENTRY_NUM asc");
		$apps_account = $this->AccountApplication->find("AccountApplication.ACCOUNT_ID = '{$id}'");

		//コンフィグを取得
		$confs = $this->Sbbconf->findAll("Sbbconf.ACCOUNT_ID = '{$id}'","*","CONF_ENTRY_NUM asc");
		
		//高度な設定を取得
		$advance['answer'] = "a";
		$advance['CONF_EXCEPT_FILE'] = $res['Account']['SBC_EXCLUDE_FILE'];
		
		//高度な設定をviewにセット
		$this->set("advance",$advance);
		$this->set("apps_account",$apps_account);
		
		//アカウント情報をviewにセット
		$this->set("account",$res);
		
		//まず配列を作り、初期化
		foreach($regularBackup as $key => $backupSetting){
			$entryNum = $backupSetting['entryNum'];
			$w[$entryNum]['Sbbconf']['CONF_ENTRY_NUM'] = $entryNum;
			$w[$entryNum]['Sbbconf']['answer'] = 'a';
		}
		foreach($optionalBackup as $key => $backupSetting){
			$entryNum = $backupSetting['entryNum'];
			$w[$entryNum]['Sbbconf']['CONF_ENTRY_NUM'] = $entryNum;
			$w[$entryNum]['Sbbconf']['answer'] = 'a';
		}
		/*
		for($i=0;$i<11;$i++){
			$w[$i]['Sbbconf']['CONF_ENTRY_NUM'] = $i;
			$w[$i]['Sbbconf']['answer'] = "a";
		}
			$w[20]['Sbbconf']['answer'] = "a";
			$w[20]['Sbbconf']['CONF_ENTRY_NUM'] = 20;
			$w[30]['Sbbconf']['answer'] = "a";
			$w[30]['Sbbconf']['CONF_ENTRY_NUM'] = 30;
			$w[40]['Sbbconf']['answer'] = "a";
			$w[40]['Sbbconf']['CONF_ENTRY_NUM'] = 40;
			
			
		for($i=50;$i<95;$i++){
			$w[$i]['Sbbconf']['CONF_ENTRY_NUM'] = $i;
			$w[$i]['Sbbconf']['answer'] = "a";
		}
		*/

		if(!empty($confs)){
			foreach($confs as $c){
				$w[$c['Sbbconf']['CONF_ENTRY_NUM']] = $c;
				$fixedpath = $this->Api->_returnFixedPath($c['Sbbconf']['CONF_ENTRY_NUM']);
				if(!empty($fixedpath)){
					$w[$c['Sbbconf']['CONF_ENTRY_NUM']]['Sbbconf']['CONF_FROM_FOLDER'] = $fixedpath;
				}
				$w[$c['Sbbconf']['CONF_ENTRY_NUM']]['Sbbconf']['answer'] = "a";
			}
		}
		$data = $w;
		
		/* 申請を取得 */
		
		if(!empty($apps)){
			$app_schedules = null;
			foreach($apps as $a){
				$data[$a['Application']['CONF_ENTRY_NUM']]['Application'] = $a['Application'];
				
				//もしスケジュールなら、スケジュールを取得して、所定の形式にする
				if(@$data[$a['Application']['CONF_ENTRY_NUM']]['Application']['CONF_SCHEDULE'] == "3"){
					$app_sche =$this->Appschedule->findAll("application_id = '".$data[$a['Application']['CONF_ENTRY_NUM']]['Application']['id']."'");
					if(!empty($app_sche)){
						$ai = 0;
						foreach($app_sche as $as){
							$app_schedules[] = $as['Appschedule']['SCHED_DAY_OF_WEEK']."/".$as['Appschedule']['SCHED_HOUR'].":".$as['Appschedule']['SCHED_MINUTE']."/".$as['Appschedule']['SCHED_STRICT_FLAG'];
							$ai++;
						}
						//$data[$a['Application']['CONF_ENTRY_NUM']]['Application']['CONF_SCHEDULES'] = implode($app_schedules,";");
					}
				}
				
				//拒否されているか、待ちか
				if(!empty($a['Application']['denied'])){
					$data[$a['Application']['CONF_ENTRY_NUM']]['Sbbconf']['answer'] = "r";//拒否
				}else{
					$data[$a['Application']['CONF_ENTRY_NUM']]['Sbbconf']['answer'] = "w";//待ち
				}
			}
		}
		
		
		/* 表示されるデータ　以上のデータをあわせたもの */
		foreach($data as $d){
			
			//現在も申請もなければ　anserは空
			if(empty($d['Sbbconf']['CONF_FROM_FOLDER']) && empty($d['Sbbconf']['CONF_TERMINAL_LAN']) && empty($d['Application']['CONF_FROM_FOLDER']) && empty($d['Application']['CONF_TERMINAL_LAN']) && empty($d['Application']['action'])){
				$data[$d['Sbbconf']['CONF_ENTRY_NUM']]['Sbbconf']['answer'] = "";
			}
			
			//現在のみある場合は承認済み扱い
			if(!empty($d['Sbbconf']['CONF_FROM_FOLDER']) && empty($d['Application'])){
				$data[$d['Sbbconf']['CONF_ENTRY_NUM']]['Sbbconf']['answer'] = "a";
			}
			
			//スケジュール代入
			if(@$d['Sbbconf']['CONF_SCHEDULE'] == "3"){
				$data[$d['Sbbconf']['CONF_ENTRY_NUM']]['Sbbconf']['CONF_SCHEDULES'] = $d['Sbbconf']['CONF_SCHEDULE_TABLE'];
			}
		}
		
		$this->set("data",$data);
		$this->render();
	}
	
	
	
	/**
	 *  SBR-CGログのアップロード 
	 */
	
	function sbrcglog(){
		exit;
		$this->uploadlog_idc("sbr-cg");
	}
	
	/**
	 *  SBR-DCログのアップロード 
	 */
	function sbrdclog(){
		$this->uploadlog_idc("sbr-dc");
	}

	/**
	 *  SBR-IGログのアップロード 
	 */
	function sbriglog(){
		$this->uploadlog_idc("sbr-ig");
	}

	/**
	 * リストアログ→オペレーションログ
	 */
	
	function restorelog($id = NULL){
		$this->layout = false;
		header("Content-type: text/plain;");
		if(empty($id) or ( strtolower($id) != "sbn" and !mb_ereg("^[0-9]+$",$id) ) ){
			echo "1\tパラメータエラー";
			exit;
		}
		if( empty($_GET['date']) or! mb_ereg("^[0-9]{8}$",$_GET['date']) ){
			echo "2\tパラメータエラー";
			exit;
		}
		
		$date = $_GET['date'];
		
		if(strtolower($id) != "sbn"){
			$id = sprintf("%03d",$id);
			$logfile = PATH_LOG.$id.DS."SBD".$id.$date.".log";
		}else{
			$id = "sbn";
			$logfile = PATH_LOG."SBN".DS."SBD".$id.$date.".log";
		}
		
		if(file_exists($logfile)){
			$check_bom = check_bom($logfile);
						
			$i = 0;
			$parent_id = NULL;
			echo "0\r\n\r\n";
			echo $logfile."を読み込み開始\r\n\r\n";
			set_time_limit(0);
			
			#読み込み
			if($check_bom){
				require_once(APP."vendors".DS."MBConvertEncodingStreamWrapper.php");
				stream_wrapper_register('mbconv', 'MBConvertEncodingStreamWrapper');
				$fp_f = fopen("mbconv://UTF-8:UTF-16LE:".$logfile,"r");
			}else{
				require_once(APP."vendors".DS."MBConvertEncodingStreamWrapper.php");
				stream_wrapper_register('mbconv', 'MBConvertEncodingStreamWrapper');
				$fp_f = fopen("mbconv://UTF-8:SJIS-win:".$logfile,"r");
			}
			
			$this->log("restorelogfile({$logfile})");
			//echo "行数:".count($file)."\r\n";
			
			if($id != "sbn"){
				$account = $this->Account->find("Account.ACCOUNT_ID = '{$id}'");
			}
			$currentMax = $this->Actionlog->find("SBD_FILENAME = '"."SBD".$id.$date.".log"."'","SBD_FILELINE","SBD_FILELINE desc");
			if(!empty($currentMax)){
				$currentlogcount = $currentMax['Actionlog']['SBD_FILELINE'];
			}else{
				$currentlogcount = 0;
			}
			
			echo $currentlogcount."行目まで登録済み\r\n";
			
			while($d = fgets($fp_f)){
				$d = delete_bom($d);
				$i++;
				//初期化
				$w = null;
				$a = null;
				$this->Actionlog->id = NULL;
				$this->data['Actionlog'] = NULL;
				$this->data['Actionlog']['SBD_FILELINE'] = $i;
				$this->data['Actionlog']['SBDLOG_PARENT_ID'] = $parent_id;
				$this->data['Actionlog']['SBD_FILENAME'] = "SBD".$id.$date.".log";
				$this->data['Actionlog']['IP_ADDRESS'] = $_SERVER['REMOTE_ADDR'];
				echo $i."\t".$d;
				//登録されている行数までは無視
				if($i <= $currentlogcount){
					continue;
				}
				
				//echo $i."行目登録\r\n";
				if($id != "sbn"){
					$this->data['Actionlog']['TYPE'] = "Secure Back Client";
					$this->data['Actionlog']['ACCOUNT_ID'] = $id;
					$this->data['Actionlog']['ACCOUNT_LOGIN_ID'] = $account['Account']['ACCOUNT_LOGIN_ID'];
					$w[] = "ID=".$id;
					$this->data['Actionlog']['ACTION'] = "Secure Back Client リストア";
				}else{
					$this->data['Actionlog']['TYPE'] = "Secure Back Notifier";
					$this->data['Actionlog']['ADMIN_ID'] = "admin";
					$w[] = "ID=admin";
					$this->data['Actionlog']['ACTION'] = "Secure Back Notifier リストア";
				}
				$data = explode("\t",$d);
				if(is_array($data)){
					$his = $data[1];
					$mdy = $data[2];
				if(eregi("\*",$data[2])){
					$w[] = "Server=datacenter";
				}
					$this->data['Actionlog']['created'] = date("Y-m-d",strtotime($date))." ".$his;
					switch($data[0]){
						case "F": //先頭フォルダ
							$this->data['Actionlog']['RESULT'] = "true";
							$w[] = "対象ファイル=".$data[4];
							$w[] = "リストア先=".$data[5];
							$this->data['Actionlog']['BEFORE'] = implode($w,"\r\n");
							$this->data['Actionlog']['AFTER'] = $data[3]."実行";
						break;
						
						case "i":
							if($data[3] == "ファイルリストア" or $data[3] == "フォルダリストア"){
								$this->data['Actionlog']['RESULT'] = "true";
								$w[] = "対象ファイル=".$data[4];
								$w[] = "リストア先=".$data[5];
								$this->data['Actionlog']['BEFORE'] = implode($w,"\r\n");
								$this->data['Actionlog']['AFTER'] = $data[3]."実行";
							}
						break;
						
						case "E":
							$this->data['Actionlog']['RESULT'] = "false";
							$w[] = "対象ファイル=".$data[4];
							if(empty($data[6])){
								$a[] = "エラー内容=".$data[5];
							}else{
								$w[] = "リストア先=".$data[5];
								$a[] = "エラー内容=".$data[6];
							}
							$this->data['Actionlog']['BEFORE'] = implode($w,"\r\n");
							$this->data['Actionlog']['AFTER'] = $data[3]."\r\n".implode($a,"\r\n");
						break;
						
						case "W":
							/*
							$this->data['Actionlog']['RESULT'] = "false";
							$w[] = "対象ファイル=".$data[4];
							$w[] = "リストア先=".$data[5];
							$this->data['Actionlog']['BEFORE'] = implode($w,"\r\n");
							$this->data['Actionlog']['AFTER'] = $data[3]."実行";
							*/
						break;
						
						default :
							var_dump($data);
							continue;
							$this->data['Actionlog']['RESULT'] = "false";
							$this->data['Actionlog']['BEFORE'] = "[".$data[3]."]".$data[4];
							$this->data['Actionlog']['AFTER'] = $data[3]."失敗";
						break;
					}
					if($data[0] == "F" or $data[0] == "E" or $data[0] == "i"){
						if(!empty($this->data['Actionlog']['BEFORE']) or !empty($this->data['Actionlog']['AFTER'])){
							$this->Actionlog->save($this->data);
							if(empty($parent_id)){
								$parent_id = $this->Actionlog->getLastInsertID();
							}
						}
					}
				}
			}
			
			//全体
			/*
			$i = preg_grep("/^i/",$file);
			$j = preg_grep("/^j/",$file);
			$F = preg_grep("/^F/",$file);
			$E = preg_grep("/^E/",$file);
			$W = preg_grep("/^W/",$file);
			*/
			
		}else{
			echo "2\t該当ファイルが読み込めませんでした\r\n";
		}
		echo "API終了";
		exit;
	}
	
	function uploadlog_new(){
		$this->uses = array('Api','Sbblog','Sbblogdetail','Account','Sbbconf','Certificationlog','Schedule');
		$this->log('Uploadlog start');
		
		if(empty($_FILES)){
			$stdin = fopen("php://input","r");
		}else{
			if(!empty($_FILES['test'])){
				$stdin = fopen($_FILES['test']['tmp_name'],"r");
			}
		}
		if(!$stdin){
			$this->log('Uploadlog Cannot fopen from stdin');
			exit;
		}
		//ここまで旧と同じ
		
		$line = 0;
		$slogdate = null;
		$file = null;
		//書き込むファイル
		//$file = $_FILES['test']['tmp_name'];
		while($txt = fgets($stdin)){
			$txt = trim($txt);
			if(!empty($txt)){
				//最初の行から　slogdate取得
				if(empty($slogdate)){
					$dateArr = explode(",",$txt);
					if(count($dateArr) == 2){
						$account_id = $dateArr[0];
						$ymd = trim($dateArr[1]);
						$date[0] = substr($ymd,0,4);
						$date[1] = substr($ymd,4,2);
						$date[2] = substr($ymd,6,2);
						if(count($date) == 3){
							$slogdate = $date[0]."-".$date[1]."-".$date[2];
						}else{
							$this->log("Uploadlog NOT CORRECT invalid SLOGDATE　= {$ymd}");
							echo "false";
							echo "invalid slogdate";
							exit;
						}
					}else{
						$this->log('Uploadlog NOT CORRECT line 2');
						echo "false";
						echo "invalid NOT CORRECT line 2";
						exit;
					}
				}
				if(!empty($slogdate)){
					if(!empty($txt)){
						//書き込んでいく
						if(empty($logname)){
							$path = PATH_LOG.sprintf("%03d",$account_id);
							if(!file_exists($path)){
								mkdir($path);
							}
							$logname = str_replace("-","",$slogdate);
							$filename = $path.DS.$logname.".log";
							$fp = fopen($filename,"w");
							fclose($fp);
						}else{
							$fp = fopen($filename,"a");
							$write = fwrite($fp,$txt,"\r\n");
							fclose($fp);
						}
						//copy($_FILES['test']['tmp_name'],$filename);
					}
				}
			}
		}
		
		//DBに登録
		
		if(!empty($account_id) && !empty($slogdate)){
			//echo $account_id.",".$slogdate;
			echo "ok";
			unset($stdin);
			$this->_sbblogupdate($account_id,$slogdate,$filename);
		}else{
			echo "false account_id slogdate";
			echo "false";
		}
		exit;
	}
	 
	/**
	 *  ログのアップロード 
	 */
	 
		
	function uploadlog_gss($id = null){
		return ;
		$debug = NULL;
		$line = 0;
		if(!empty($_GET['readfrom']) && mb_eregi("[0-9]*",$_GET['readfrom'])){
			$line = $_GET['readfrom'];
		}
		if($debug){
			echo "SBC logアップロード<br>";
		}
		
		$cln = new Sanitize;
		if(!empty($_GET['date']) && !empty($id)){
			$date = addslashes($_GET['date']);
			
			$filename_sbc = "sbc".sprintf("%03d",$id).$date.".log";
			$filename = "sbc".sprintf("%03d",$id).$date.".log.txt";
			
			if(strlen($date) == 8){
				$yyyy = substr($date,0,4);
				$mm = substr($date,4,2);
				$dd = substr($date,6,2);
				$slogdate = $yyyy."-".$mm."-".$dd;
				
				if($debug)echo $id.":".$slogdate."<br>";
			}else{
				$this->log("Uploadlog_GSS NOT CORRECT invalid SLOGDATE　= {$slogdate}");
				if($debug)echo "SBC logアップロード失敗 dateがありません<br>";
				exit;
			}
		}else{
			echo "upload log failed";
			$this->log("Uploadlog_GSS {$id} NOT CORRECT invalid date");
			exit;
		}
		
		if(!empty($id)){
			$id = (int)addslashes($id);
		}else{
			echo "upload log failed";
			$this->log("Uploadlog_GSS {$id} NOT CORRECT invalid ID");
			exit;
		}
		
		if(!empty($id) && !empty($slogdate) && !empty($filename_sbc)){
			
			$path = PATH_LOG.sprintf("%03d",$id);
			
			if(file_exists($path.DS.$filename_sbc)){
				$this->log("logpath=".$path.DS.$filename_sbc);
				if(copy($path.DS.$filename_sbc,$path.DS.$filename)){
					$this->Actionlog->debug_log("copy ".$path.DS.$filename_sbc." , ".$path.DS.$filename,$id);
				}
			}
			
			if(file_exists($path.DS.$filename)){
				
				if($debug)echo $path.DS.$filename."<br>";
				$this->_sbblogGrep($id,$slogdate,$path.DS.$filename,$debug,$line);
			}else{
				echo "upload log failed";
				if($debug)echo "not exists".$path.DS.$filename."<br>";
				$this->log("Uploadlog NOT EXISTS logfile -> ".$path.DS.$filename);
				exit;
			}
			
			// {{ ここまで
		}
		echo "<br>";
		echo $path.DS.$filename."<br>";
		if(file_exists($path.DS.$filename)){
			//@unlink($path.DS.$filename);
		}
		echo "ok";
		
		if(@SBM_DEBUGLOG==1) $this->Actionlog->debug_log(' }} uploadlog end id='.$id.' date='.date("Y-m-d H:i;s"),$id);
		exit;
	}
	
	function logAnalyze($id,$slogdate,$filename,$date,$line){
		$debug = false;
		$filename_sbc = "sbc".$date.".log";
		$filename_sbc2 = "sbc".sprintf("%03d",$id).$date.".log";
		if(!empty($id) && !empty($slogdate) && !empty($filename)){
			$path = PATH_LOG.sprintf("%03d",$id);
			
			if(file_exists($path.DS.$filename_sbc2)){
				$this->log("logpath=".$path.DS.$filename_sbc2);
				@unlink($path.DS.$filename);
				if(copy($path.DS.$filename_sbc2,$path.DS.$filename)){
					//unlink($path.DS.$filename_sbc2);
				}
			}elseif(file_exists($path.DS.$filename_sbc)){
				$this->log("logpath=".$path.DS.$filename_sbc);
				@unlink($path.DS.$filename);
				if(copy($path.DS.$filename_sbc,$path.DS.$filename)){
					//unlink($path.DS.$filename_sbc);
				}
			}
			
			if(file_exists($path.DS.$filename)){
				
				if($debug)echo $path.DS.$filename."<br>";
				$this->_sbblogGrep($id,$slogdate,$path.DS.$filename,$debug,$line);
				@unlink($path.DS.$filename);
			}else{
				echo "upload log failed";
				if($debug)echo "not exists".$path.DS.$filename."<br>";
				$this->log("Uploadlog NOT EXISTS logfile -> ".$path.DS.$filename);
				exit;
			}
		}
		exit;
	}
	
	function uploadlog($id){
		echo "0";exit;
		$this->_heartbeat($id,"api/uploadlog");
		$this->log("uploadlog type => gss");
		$this->uploadlog_gss($id);
	}
	 
	function uploadlog_sbc(){
		
		$this->uses = array('Api','Sbblog','Sbblogdetail','Account','Sbbconf','Certificationlog','Schedule');
		
		//W 警告
		//E エラー
		//j フォルダ作成
		//i 
		//F 転送完了			
			//postのテスト
    	$this->log('Uploadlog start');
			if(empty($_FILES)){
				$stdin = fopen("php://input","r");
			}else{
				if(!empty($_FILES['test'])){
					$stdin = fopen($_FILES['test']['tmp_name'],"r");
				}
			}
			$this->log($t);
			
			if(!$stdin){
				$this->log('Uploadlog Cannot fopen from stdin');
				exit;
			}
			$line = 0;
			while($txt = fgets($stdin)){
				$txt = trim($txt);
				if(!empty($txt)){
					$file[$line] = $txt;
				}
				$line++;
			}
			fclose($stdin);
			$confline = $file[1];
			$file[1] = "";
			//一旦implodeしてtrimをかける
			$logtext = implode($file,"\r\n");
			$file = explode("\r\n",$logtext);
			
			//以降は同じ処理
			
			$confArr = explode(",",$confline);
			if(count($confArr) == 2){
				$account_id = $confArr[0];
				$ymd = trim($confArr[1]);
				$date[0] = substr($ymd,0,4);
				$date[1] = substr($ymd,4,2);
				$date[2] = substr($ymd,6,2);
				//dateが無いときerrorが出て他ので回避
				if(count($date) == 3){
					$slogdate = $date[0]."-".$date[1]."-".$date[2];
				}else{
					$this->log("Uploadlog NOT CORRECT invalid SLOGDATE　= {$ymd}");
					exit;
				}
				$i = 0;
			}else{
				$this->log('Uploadlog NOT CORRECT line 2');
				exit;
			}
			$this->log("Uploadlog account_id = {$account_id},{$slogdate}");
			
			if(!empty($account_id) && !empty($slogdate)){
				
			$this->_heartbeat($account_id,"api/uploadlog");
				//保存先
				$path = PATH_LOG.sprintf("%03d",$account_id);
				//ファイル書き込み
				reset($file);
				if(!file_exists($path)){
					mkdir($path);
				}
				$logname = str_replace("-","",$slogdate);
				$filename = $path.DS."{$logname}.log";
				
				//追記してたのを書き換えに test
				 
				if(file_exists($filename)){
					$fp = fopen($filename,"w") or die("ERROR FILE OPEN W ->{$logname}.log");
				}else{
					$fp = fopen($filename,"w") or die("ERROR FILE OPEN W ->{$logname}.log");
				}
				
				$write = fwrite($fp,implode($file,"\r\n"));
				fclose($fp);
				$this->_sbblogupdate($account_id,$slogdate,$filename);
			}
			$this->log('Uploadlog end');
			echo "ok";
		exit;
	}
	
	
	
	function uploadlog_idc($type = "sbr-dc"){
	
		if(!empty($_GET['date'])){
			$this->log("uploadlog_idc {$type} type => gss");
			$this->uploadlog_idc_gss($type);
		}else{
			$this->log("uploadlog_idc {$type} type => sbc");
			$this->uploadlog_idc_sbc($type);
		}
	}
	
	function uploadlog_idc_gss($type = "sbr-dc"){
		$cln = new Sanitize;
		if(!empty($_GET['date'])){
			$date = addslashes($_GET['date']);
			$filename = $date.".log";
			if(strlen($date) == 8){
				$yyyy = substr($date,0,4);
				$mm = substr($date,4,2);
				$dd = substr($date,6,2);
				$slogdate = $yyyy."-".$mm."-".$dd;
				
			}else{
				$this->log("Uploadlog_idc NOT CORRECT invalid SLOGDATE　= {$slogdate}");
				exit;
			}
		}else{
			echo "upload log failed";
			$this->log("Uploadlog_idc {$id} NOT CORRECT invalid date");
		}
		if(!empty($slogdate) && !empty($filename)){
			//保存先
			switch($type){
				case "sbr-dc":
				$path = PATH_LOG."SBR-DC";
				$filename_sbc = "SBR-DC".$filename;
				break;
				case "sbr-ig":
				$path = PATH_LOG."SBR-IG";
				$filename_sbc = "SBR-IG".$filename;
				break;
				
				case "sbr-cg":
				$path = PATH_LOG."SBR-CG";
				$filename_sbc = "SBR-CG".$filename;
				break;
			}
			if(file_exists($path.DS.$filename_sbc)){
				@unlink($path.DS.$filename);
				if(copy($path.DS.$filename_sbc,$path.DS.$filename)){
					unlink($path.DS.$filename_sbc);
				}
			}
			echo $path.DS.$filename;
			var_dump(file_exists($path.DS.$filename));
			//アップデート
			if(file_exists($path.DS.$filename)){
				switch($type){
					case "sbr-dc":
						$this->log("_idclogupdate({$slogdate},{$filename})");
						$this->_dclogupdate($slogdate,$path.DS.$filename);
					break;
					case "sbr-ig":
						$this->log("_iglogupdate({$slogdate},{$filename})");
						$this->_iglogupdate($slogdate,$path.DS.$filename);
					break;
					case "sbr-cg":
						$this->log("_cglogupdate({$slogdate},{$filename})");
						$this->_cglogupdate($slogdate,$path.DS.$filename);
					break;
				}
			}
		}
		exit;
		
	}
	
	function uploadlog_idc_sbc($type = "sbr-dc"){
		$this->$uses = array('Api','Sbblog','Sbblogdetail','Account','Sbbconf','Certificationlog','Schedule');
		//W 警告
		//E エラー
		//j フォルダ作成
		//i 
		//F 転送完了			
			//postのテスト
    	$this->log('Uploadlog start');
			if(empty($_FILES)){
				$stdin = fopen("php://input","r");
			}else{
				if(!empty($_FILES['test'])){
					$stdin = fopen($_FILES['test']['tmp_name'],"r");
				}
			}
			if(!$stdin){
				$this->log('Uploadlog Cannot fopen from stdin');
				exit;
			}
			$line = 0;
			while($txt = fgets($stdin)){
				$txt = trim($txt);
				if(!empty($txt)){
					$file[$line] = $txt;
				}
				$line++;
			}
			fclose($stdin);
			
			//一旦implodeしてtrimをかける
			$logtext = trim(implode($file,"\r\n"));
			$file = explode("\r\n",$logtext);
			$ymd = "";
			//1行目から日付をとりだす
			$l = array_shift($file);
			$line1 = explode(",",$l);
			$this->log("Uploadlog_idc line1 = ".$l);
			if(!empty($line1[1])){
				$ymd = substr($line1[1],0,4).substr($line1[1],4,2).substr($line1[1],6,2);
			}else{
				$this->log("Uploadlog_idc NOT CORRECT invalid SLOGDATE　= {$ymd}");
				exit;
			}
			
			//以降は同じ処理
			
			if( $type == "sbr-dc" || $type == "sbr-ig"){
				
				$date[0] = substr($ymd,0,4);
				$date[1] = substr($ymd,4,2);
				$date[2] = substr($ymd,6,2);
				//dateが無いときerrorが出て他ので回避
				if(count($date) == 3){
					$slogdate = $date[0]."-".$date[1]."-".$date[2];
				}
				$i = 0;
			}else{
				$this->log('Uploadlog NOT CORRECT line 2');
				exit;
			}
			$log = "Uploadlog:{$type}: {$slogdate}";
			if($type == "sbr"){
				$log .= ",account_id = {$account_id}";
			}
			$this->log($log);
			
			if(!empty($slogdate)){
			
				//保存先
				switch($type){
					case "sbr":
					$path = PATH_LOG.sprintf("%03d",$account_id);
					break;
					case "sbr-dc":
					$path = PATH_LOG."SBR-DC";
					break;
					case "sbr-ig":
					$path = PATH_LOG."SBR-IG";
					break;
					case "sbr-cg":
					$path = PATH_LOG."SBR-CG";
					break;
				}
				//ファイル書き込み
				reset($file);
				if(!file_exists($path)){
					mkdir($path);
				}
				$logname = str_replace("-","",$slogdate);
				$filename = $path.DS."{$logname}.log";
				
				//追記してたのを書き換えに test
				 
				if(file_exists($filename)){
					$fp = fopen($filename,"w") or die("ERROR FILE OPEN W ->{$logname}.log");
				}else{
					$fp = fopen($filename,"w") or die("ERROR FILE OPEN W ->{$logname}.log");
				}
				
				$write = fwrite($fp,implode($file,"\r\n"));
				fclose($fp);
				echo "ok";
				switch($type){
					case "sbr":
						$this->_sbblogupdate($account_id,$slogdate,$filename);
					break;
					case "sbr-dc":
						$this->_dclogupdate($slogdate,$filename);
					break;
					case "sbr-ig":
						$this->_iglogupdate($slogdate,$filename);
					break;
				}
			}
			$this->log('Uploadlog end');
		exit;
	}
	
	/**
	 *  ログのアップロードテスト
	 */
	
	function testuploadlog(){
		
	}

  function svn_up() {
    list($retval, $output) = $this->Cmd->_exec(sprintf('"C:\Program Files\Subversion\bin\svn" up --username=sbs --password=P@q826$E %s', APP));
    header('Content-Type: text/plain');
    echo join("\r\n", $output);
    echo "\r\n";
    echo sprintf("終了コード: %d", $retval);
    exit;
  }
	
	function restart_duservice(){
		$this->Cmd->duervice_restart($data);
	}
	function restart_gss(){
		$this->Cmd->gss_restart($data);
	}
	
	
	function restart(){
		//Configure::write('debug', 2);
		ob_start();
		$this->layout = "update";
		$this->pageTitle = "Secure Back Managerの再起動";
		
		//オペレーションログ登録
		$admin = $this->Session->read("Admin");
		if(empty($admin)){
			$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"Secure Back Manageの再起動","Secure Back Manageの再起動","実行","true");
		}else{
			$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","Secure Back Manageの再起動","Secure Back Manageの再起動","実行","true");	
		}
		sleep(10);
		
		$second = 300;
		$this->set("second",$second);
		$url = $_SERVER['REQUEST_URI'];
		
		$data['Admin']['ADMIN_LOGIN'] = NULL;
		$data['Admin']['id'] = 1;
		$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
		$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
			$this->Admin->id=1;
		$this->Admin->save($data,false);
		$this->Session->del("Admin");
		
		$redirecturl = str_replace("api/restart/","admin/login",$url);
		header('Refresh: '.$second.';URL='.$redirecturl);
		$this->set("redirecturl",$redirecturl);
		
			$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
			if (!$fs) { 
				$this->log("fsockopen Error: $errstr ($errno)<br>\n");
			} else { 
				socket_set_blocking($fs, false); 
			fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/restart_all/ HTTP/1.0\r\n\r\n");
				fclose ($fs); 
			}
		$this->render();
	}
	
	function restart_sbs(){
		ob_start();
		$this->layout = "update";
		$this->pageTitle = "バックアップサーバの再起動";
		
		//オペレーションログ登録
		$admin = $this->Session->read("Admin");
		if(empty($admin)){
			$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"バックアップサーバの再起動ト","バックアップサーバの再起動","実行","true");
		}else{
			$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","バックアップサーバの再起動","バックアップサーバの再起動","実行","true");	
		}
		sleep(10);
		
		$second = 600;
		$this->set("second",$second);
		$url = $_SERVER['REQUEST_URI'];
		
		$data['Admin']['ADMIN_LOGIN'] = NULL;
		$data['Admin']['id'] = 1;
		$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
		$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
		$this->Admin->id=1;
		$this->Admin->save($data,false);
		$this->Session->del("Admin");
		
		$redirecturl = str_replace("api/restart_sbs/","admin/login",$url);
		header('Refresh: '.$second.';URL='.$redirecturl);
		$this->set("redirecturl",$redirecturl);
		if(!defined("TESTMACHINE")){
			$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
			if (!$fs) { 
				$this->log("fsockopen Error: $errstr ($errno)<br>\n");
			} else { 
				socket_set_blocking($fs, false); 
				fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/restart_system/ HTTP/1.0\r\n\r\n"); 
				fclose ($fs); 
			}
		}
		$this->render();
	}
	
	function shutdown_sbs(){
		ob_start();
		$this->layout = "update";
		$this->pageTitle = "バックアップサーバのシャットダウン";
		
		//オペレーションログ登録
		$admin = $this->Session->read("Admin");
		if(empty($admin)){
			$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"バックアップサーバのシャットダウン","バックアップサーバのシャットダウン","実行","true");
		}else{
			$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","バックアップサーバのシャットダウン","バックアップサーバのシャットダウン","実行","true");	
		}
		sleep(10);
		
		$redirecturl = str_replace("api/shutdown_sbs/","admin/login",$url);
		$this->set("redirecturl",$redirecturl);
		
		$data['Admin']['ADMIN_LOGIN'] = NULL;
		$data['Admin']['id'] = 1;
		$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
		$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
		$this->Admin->id=1;
		$this->Admin->save($data,false);
		$this->Session->del("Admin");
		
		if(!defined("TESTMACHINE")){
			$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
			if (!$fs) { 
				$this->log("fsockopen Error: $errstr ($errno)<br>\n");
			} else { 
				socket_set_blocking($fs, false); 
				fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/shutdown/ HTTP/1.0\r\n\r\n"); 
				fclose ($fs); 
			}
		}
		$this->render();
	}
	
	function systemupdate(){
		$this->sbw_update();
		return;
		$last = APP.DS."config".DS."SBMupdate.txt";
		$this->set('HTTP_HOST',$_SERVER['HTTP_HOST']);
		ob_start();
		
		$this->layout = "update";
		$this->pageTitle = "システムのアップデート";
		$data['version'] = "?";
		//現在のversion
		$file = APP."..".DS."rev".DS."history.txt";
		if(file_exists($file)){
			$txt = file($file);
			if(!empty($txt[0])){
				$history = explode("\t",$txt[0]);
				$data['version'] = $history[0];
			}
		}
		$admin = $this->Session->read("Admin");
		if(empty($admin)){
			$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"システムのアップデート","バージョン={$data['version']}","実行","true");
		}else{
			$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","システムのアップデート","システムのアップデート","実行","true");	
		}
		sleep(10);
		
		$fp = fopen(APP."config".DS."SBMupdate.txt","w");
		$date = date("Y-m-d H:i:s");
		$res = fwrite($fp,$date);
		fclose($fp);
			
		$url = $_SERVER['REQUEST_URI'];
		
		$data['Admin']['ADMIN_LOGIN'] = NULL;
		$data['Admin']['id'] = 1;
		$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
		$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
		$this->Admin->id=1;
		$this->Admin->save($data,false);
		$this->Session->del("Admin");
		$this->Session->del("SBM");
		
		if(!defined("TESTMACHINE")){
			$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
			if (!$fs) { 
				$this->log("fsockopen Error: $errstr ($errno)<br>\n");
			} else { 
				socket_set_blocking($fs, false); 
				fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/update_sbs/ HTTP/1.0\r\n\r\n"); 
				fclose ($fs); 
			}
		}
		$this->render();
	}
	
	function sbrigupdate(){
		//sbrigはいじらない
		echo "ok";
		exit;
	}
	
	function sbrdcupdate(){
		//スケジュール取得格納
		$conf = $this->Sbbconf_foridc->find(null,"CONF_SCHEDULE,CONF_CYCLETIME,CONF_IDLEWAIT,CONF_SCHEDULE_TABLE");
		
		if(!empty($conf['Sbbconf_foridc'])){
			$f['NoDetect0'] = $conf['Sbbconf_foridc']['CONF_SCHEDULE'];
			$f['DoOnIdle0'] = 0;
			$f['DoInterval0'] = 0;
			$f['Schedule0'] = "";
			
			switch($conf['Sbbconf_foridc']['CONF_SCHEDULE']){
				case "0":
				
				break;
				case "1":
					$f['DoInterval0'] = $conf['Sbbconf_foridc']['CONF_CYCLETIME']*60;
				break;
				case "2":
					$f['DoOnIdle0'] = $conf['Sbbconf_foridc']['CONF_IDLEWAIT'];
				break;
				case "3":
					if(!empty($conf['Sbbconf_foridc']['CONF_SCHEDULE_TABLE'])){
					$f['Schedule0'] = $conf['Sbbconf_foridc']['CONF_SCHEDULE_TABLE'];
					}
				break;
			}
		}
		
		//config書き換え
			$file_dc = implode(file(SBRDC_CFG),"");
			if(ereg("WabTeSpeed\=[0-9]*",$file_dc,$match)){
				//echo "1";
				//var_dump($match);
				$file_dc = str_replace($match[0],"WabTeSpeed=".SBRDCWABTESPEED,$file_dc);
			}else{
				//echo "2";
				if(ereg(";\r\n\[Setting\]",$file_dc,$match)){
					$file_dc = str_replace($match[0],$match[0]."\r\n;\r\n;\r\nWabTeSpeed=".SBRDCWABTESPEED,$file_dc."\r\n;\r\n;");
					//var_dump($match);
				}
			}
			
			//f 置換
			if(!empty($f)){
				while(list($fn,$fv) = each($f)){
					$ereg = $fn."=[^ \t\n\r\f]*";
					//echo $ereg."<br>";
					if(mb_ereg($ereg,$file_dc,$match)){
						$file_dc = str_replace($match[0],$fn."=".$fv,$file_dc);
						//var_dump($match);
					}
					//echo "<br>";
				}
				//echo "<pre>";
				//echo $file_dc;
				//exit;
			}
			
			$fp = fopen(SBRDC_CFG,"w");
			fwrite($fp,$file_dc);
			if($fp) fclose($fp);
		
		$this->Cmd->updateConfig_restart();
		echo "ok";
		exit;
	}

	function logText2BackuplogCount(){
		$cln = new Sanitize;
		$logTextPath = PATH_LOG.'counts'.DS;

		if(!empty($_GET['date'])){
			$date = addslashes($_GET['date']);
		}else{
			echo 'parameter error';
			exit;
		}
		$logText = $logTextPath.$date.'.log';

		if(file_exists($logText)){
			$rowData = file($logText);
			foreach($rowData as $log){
				$data = explode("\t",$log);
				$logDate = $data[0];
				$queryString = $data[1];
				$url = 'http://' . SBS_LOCAL_ADDRESS . '/api/reg_backuplog_count'.$queryString;
				echo $url;
				$res = file_get_contents($url);
				var_dump($res);
				exit;
			}
		}

		exit;
	}
	function reg_backuplog_count_sbr_cg(){
		$cln = new Sanitize;
		$isCorrectMustValue = true;
		$ret = '0';
		//ログテキストパス
		$logTextPath = PATH_LOG.'counts'.DS.'sbr_cg'.DS;
		$logTextName = $logTextPath.date('Y-m-d').'.log';
		//ログテキストパスがなかったら作成
		if(!file_exists($logTextPath)) mkdir($logTextPath);
		//入力チェック&サニタイズ
		$values = array(
			'date','time','dir','f','i','j','w','e'
		);
		$slogKinds = array(
			'F','i','j','W','E'
			);

		foreach($values as $value){
			if(!isset($_GET[$value])){
				$isCorrectMustValue = false;
				$nonCorrectValue[] = $value;
				break;
			}else{
				if($value != "dir"){
					$data['Log'][$value] = addslashes($_GET[$value]);
				}else{
					$data['Log'][$value] = stripslashes($_GET[$value]);
				}

			}
		}
		$serverQuery = str_replace('url=api/reg_backuplog_count_sbr_cg','',$_SERVER['QUERY_STRING']);

		if($isCorrectMustValue && $res['ret'] == 0){
			//ログカウントをDBに保存
			//今日のログを取得
			$sDate = date("Y-m-d",strtotime($data['Log']['date']));
			$sID = $sDate;
			$sDir = $data['Log']['dir'];
			$sTime = addslashes($data['Log']['time']);
			$currentData = $this->CglogVer3->findById($sID);
			$data['CglogVer3']['id'] = $sID;
			$data['CglogVer3']['log_date'] = $sDate;
			
			reset($slogKinds);
			foreach($slogKinds as $slogKind){
				$fieldName = 'count_'.$slogKind;
				$count = 0;
				if(!empty($currentData['CglogVer3'][$fieldName])){
					$count += $currentData['CglogVer3'][$fieldName];
				}
				$count += $data['Log'][strtolower($slogKind)];
				$data['CglogVer3'][$fieldName] = $count;
			}

			$this->CglogVer3->id = $sID;
			$this->CglogVer3->save($data);
			echo "0";
			//テキストに引数を遺す
			$fp = fopen($logTextName,'a');
			if(!$fp){
				$ret = '1';
			}else{
				$writeText = $sDate."\t"
				. $data['Log']['time']."\t"
				. $sAccountID."\t"
				. $sEntryNum."\t"
				. $sDir."\t"
				. "f=".$data['Log']['f']."\t"
				. "i=".$data['Log']['i']."\t"
				. "j=".$data['Log']['j']."\t"
				. "w=".$data['Log']['w']."\t"
				. "e=".$data['Log']['e']."\t"
				. "\r\n";
				$write = fwrite($fp,$writeText);
				if(!$write) $ret = '1';
			}

			exit;
		}
	}

	/* ログカウントメソッド */

	private function _setLogTextPath() {
		//ログテキストパス
		$logTextPath = PATH_LOG.'counts'.DS;
		$logTextName = $logTextPath.date('Y-m-d').'.log';
		//ログテキストパスがなかったら作成
		if(!file_exists($logTextPath)) mkdir($logTextPath);
		return $logTextName;
	}

	private function _setLogDataFromGetParams($mode = 'add') {
		$cln = new Sanitize;

		$logs = array();
		$isCorrectMustValue = true;
		$nonCorrectValue = array();

		$values['add'] = array(
			'date','time','dir','f','i','j','w','e'
		);
		$values['replace'] = array(
			'date','dir','f','i','j','w','e'
		);

		foreach($values[$mode] as $value){
			if(!isset($_GET[$value])){
				$isCorrectMustValue = false;
				$nonCorrectValue[] = $value;
				break;
			}else{
				if($value != "dir"){
					$logs[$value] = addslashes($_GET[$value]);
				}else{
					$logs[$value] = stripslashes($_GET[$value]);
				}

			}
		}
		return array($logs, $isCorrectMustValue, $nonCorrectValue);
	}

	/** 
	 * 新方式のログカウント
	 * method GET
	 * pw
	 * date
	 * time
	 * dir
	 * f,i,j,w,e
	 */
	function reg_backuplog_count($rowAccountID){
		$cln = new Sanitize;
		$isCorrectMustValue = true;
		$ret = '0';
		$logTextName = $this->_setLogTextPath();
		
		//IDの検証
		$sAccountID = sprintf("%03d",addslashes($rowAccountID));
		$data = $this->Account->find("Account.ACCOUNT_ID = '{$sAccountID}'");
		$res = $this->Api->login($data);

		//入力チェック&サニタイズ
		list($data['Log'], $isCorrectMustValue, $nonCorrectValue) = $this->_setLogDataFromGetParams();
		$slogKinds = array(
			'F','i','j','W','E'
		);

		$serverQuery = str_replace('url=api/reg_backuplog_count','',$_SERVER['QUERY_STRING']);
		//死活監視ログ登録
		$this->_heartbeat($sAccountID,"api/login");
		
		if($isCorrectMustValue && $res['ret'] == 0){
			//ログカウントをDBに保存
			//今日のログを取得
			$y = substr($data['Log']['date'],0,4);
			$m = substr($data['Log']['date'],4,2);
			$d = substr($data['Log']['date'],6,2);
			$sDate = $y.'-'.$m.'-'.$d;
			$sID = $sAccountID.'_'.$sDate;
			$sDir = $data['Log']['dir'];
			$sTime = addslashes($data['Log']['time']);
			$currentData = $this->SbblogVer3->findById($sID);
			$data['SbblogVer3']['id'] = $sID;
			$data['SbblogVer3']['account_id'] = $sAccountID;
			$data['SbblogVer3']['log_date'] = $sDate;
			//sbb_log_ver3へはアカウントごとの合計
			reset($slogKinds);
			foreach($slogKinds as $slogKind){
				$fieldName = 'count_'.$slogKind;
				$count = 0;
				if(!empty($currentData['SbblogVer3'][$fieldName])){
					$count += $currentData['SbblogVer3'][$fieldName];
				}
				$count += $data['Log'][strtolower($slogKind)];
				$data['SbblogVer3'][$fieldName] = $count;
			}

			$this->SbblogVer3->id = $sID;
			$this->SbblogVer3->save($data);
			
			//バックアップもとの詳細を取得
			$backupSetting = $this->BackupSetting->getFromDir2Data($sDir);
			$sEntryNum = sprintf('%03d',$backupSetting['entryNum']);

			if($sDir != '*'){
				//sbb_log_detail_ver3へはバックアップ元ごと
				$this->SbblogdetailVer3->unbindModel(
					array('belongsTo' => array('Account'))
				);
				$currentDetailData = $this->SbblogdetailVer3->find(
					"SbblogdetailVer3.folder = '".addslashes($sDir)."' and SbblogdetailVer3.log_date = '{$sDate}' and SbblogdetailVer3.account_id = '{$sAccountID}'",
					'*',
					null,
					null,
					null,
					-1
				);

				$data['SbblogdetailVer3']['account_id'] = $sAccountID;
				$data['SbblogdetailVer3']['log_date'] = $sDate;
				reset($slogKinds);
				
				if(!empty($currentDetailData['SbblogdetailVer3']['id'])){
					$sDetailID = $currentDetailData['SbblogdetailVer3']['id'];
				}else{
					$sDetailID = md5($sAccountID.$sDate.$sDir);
				}

				foreach($slogKinds as $slogKind){
					$fieldName = 'count_'.$slogKind;
					$count = 0;
					if(!empty($currentDetailData['SbblogdetailVer3'][$fieldName])){
						$count += $currentDetailData['SbblogdetailVer3'][$fieldName];
					}
					$count += $data['Log'][strtolower($slogKind)];
					$data['SbblogdetailVer3'][$fieldName] = $count;
				}

				$data['SbblogdetailVer3']['id'] = $this->SbblogdetailVer3->id = $sDetailID;
				$data['SbblogdetailVer3']['type'] = '';
				$data['SbblogdetailVer3']['folder'] = $sDir;
				$data['SbblogdetailVer3']['entry_num'] = $sEntryNum;
				$data['SbblogdetailVer3']['name'] = !empty($backupSetting['dirname'])?$backupSetting['dirname']:$sDir;
				$sbblogDetailSaveResult = $this->SbblogdetailVer3->save($data);
				if(!$sbblogDetailSaveResult){
					$ret = 1;
				}
			}
			//テキストに引数を遺す
			$fp = fopen($logTextName,'a');
			if(!$fp){
				$ret = '1';
			}else{
				$writeText = $data['Log']['date']."\t"
					. $data['Log']['time']."\t"
					. $sAccountID."\t"
					. $sEntryNum."\t"
					. $sDir."\t"
					. "f=".$data['Log']['f']."\t"
					. "i=".$data['Log']['i']."\t"
					. "j=".$data['Log']['j']."\t"
					. "w=".$data['Log']['w']."\t"
					. "e=".$data['Log']['e']."\t"
					. "\r\n";
				$write = fwrite($fp,$writeText);
				if(!$write) $ret = '1';
			}
		}else{
			$ret = '1';
		}
		echo $ret;
		exit;
	}

	/**
	 * #473 [SBC]ログカウント補正
	 * @params account_id
	 * @params GET date
	 * @params GET dir
	 * @params GET f
	 * @params GET i
	 * @params GET j
	 * @params GET w
	 * @params GET e
	 * @return 0 正常に登録 1 登録できない
	 */
	function replace_backuplog_count($rowAccountID) {
		$fields = array(
			'id', 'account_id',
			'log_date',
			'count_i', 'count_j', 'count_E', 'count_W', 'count_F', 'count_j',
			'type',
			'folder',
			'entry_num',
			'name'
		);

		$counts = array(
			'i' => 'count_i',
			'j' => 'count_j',
			'e' => 'count_E',
			'w' => 'count_W',
			'f' => 'count_F'
		);

		$cln = new Sanitize;
		$logTextName = $this->_setLogTextPath();
		$sAccountID = sprintf("%03d",addslashes($rowAccountID));

		try {
			//アカウント取得
			$data = $this->Account->find("Account.ACCOUNT_ID = '{$sAccountID}'");

			//アカウントエラー
			if(empty($data)) throw new Exception ('not exists');

			//入力値チェック
			list($data['Log'], $isCorrectMustValue, $nonCorrectValue) = $this->_setLogDataFromGetParams('replace');

			//入力エラー
			if(!$isCorrectMustValue) throw new Exception ('parameter error');

			//データ生成
			$date = strtotime($data['Log']['date']);
			$sDate = date('Y-m-d', $date);
			$sDir = $data['Log']['dir'];
			$sDetailID = md5($sAccountID.$sDate.$sDir);

			//バックアップもとの詳細を取得
			$backupSetting = $this->BackupSetting->getFromDir2Data($sDir);
			$sEntryNum = sprintf('%03d',$backupSetting['entryNum']);

			foreach($data['Log'] as $index => $value) {
				if(isset($counts[$index])) {
					$data['SbblogdetailVer3'][$counts[$index]] = $value;
				}
			}

			//更新
			$this->SbblogDetailVer3->id = $sDetailID;
			$data['SbblogdetailVer3']['id'] = $sDetailID;
			$data['SbblogdetailVer3']['folder'] = $sDir;
			$data['SbblogdetailVer3']['log_date'] = $sDate;
			$data['SbblogdetailVer3']['account_id'] = $sAccountID;
			$data['SbblogdetailVer3']['entry_num'] = $sEntryNum;
			$data['SbblogdetailVer3']['name'] = !empty($backupSetting['dirname'])?$backupSetting['dirname']:$sDir;

			$res = $this->SbblogdetailVer3->save($data);
			if(!$res) throw new Exception('save error'); 
			$result = "0";
		} catch (Exception $e) {
			$result = "1\t".$e->getMessage();
		}
		echo $result;
		exit;
	}
	
	/**
	 * #473 [SBR-CG]ログカウント補正
	 * @params GET date
	 * @params GET dir
	 * @params GET f
	 * @params GET i
	 * @params GET j
	 * @params GET w
	 * @params GET e
	 * @return 0 正常に登録 1 登録できない
	 */
	function replace_backuplog_count_sbr_cg() {
		$isCorrectMustValue = true;
		$cln = new Sanitize;
		$values = array(
			'date','f','i','j','w','e'
		);
		$res = '';
		$slogKinds = array(
			'F','i','j','W','E'
			);

		//入力チェック&サニタイズ
		try {
			foreach($values as $value){
				if(!isset($_GET[$value])){
					$isCorrectMustValue = false;
					break;
				}else{
					$data['Log'][$value] = addslashes($_GET[$value]);
				}
			}
			if(!$isCorrectMustValue) throw new Exception('parameter error');

			$sDate = date("Y-m-d",strtotime($data['Log']['date']));
			$sID = $sDate;
			$data['CglogVer3']['id'] = $sID;
			$data['CglogVer3']['log_date'] = $sDate;
			
			reset($slogKinds);
			foreach($slogKinds as $slogKind){
				$fieldName = 'count_'.$slogKind;
				$count = 0;
				if(!empty($currentData['CglogVer3'][$fieldName])){
					$count += $currentData['CglogVer3'][$fieldName];
				}
				$count += $data['Log'][strtolower($slogKind)];
				$data['CglogVer3'][$fieldName] = $count;
			}

			$this->CglogVer3->id = $sID;
			$result = $this->CglogVer3->save($data);
			if(!$result) throw new Exception('save error');
			$res = '0';
		} catch (Exception $e) {
			$res = "1\t".$e->getMessage();
		}
		echo $res;
		exit;
	}

	/**
	 * #473 [SBC]ログカウント補正 アカウント合計
	 * @params GET date
	 * @params GET dir
	 * @params GET f
	 * @params GET i
	 * @params GET j
	 * @params GET w
	 * @params GET e
	 * @return 0 正常に登録 1 登録できない
	 */
	function update_backuplog_count($rowAccountID) {
		header('Content-type: text/html');
		$cln = new Sanitize;
		$sAccountID = sprintf("%03d",addslashes($rowAccountID));
		$res = '';
		$counts = array(
			'i' => 'count_i',
			'j' => 'count_j',
			'f' => 'count_F',
			'e' => 'count_E',
			'w' => 'count_W',
		);

		try {
			//アカウント取得
			$account = $this->Account->find("Account.ACCOUNT_ID = '{$sAccountID}'");

			//アカウントエラー
			if(empty($account)) throw new Exception ('not exists');

			//parameter エラー
			if(empty($this->params['url']['date']) || !ereg("^[0-9]{4}-?[0-9]{2}-?[0-9]{2}$", $this->params['url']['date'])) {
				throw new Exception ('parameter error');
			}

			$sDate = date('Y-m-d', strtotime($this->params['url']['date']));
			$conditions = 
				"SbblogdetailVer3.log_date = '{$sDate}' and ".
				"SbblogdetailVer3.account_id = '{$sAccountID}' ".
				"group by SbblogdetailVer3.log_date"
			;
			foreach($counts as $index => $value) {
				$fields[] = 'sum('. $value . ') as ' . $value;
			}
			$count = $this->SbblogdetailVer3->find($conditions, $fields);
			if(empty($count)) throw new Exception('empty');

			$data['SbblogVer3'] = $count[0];
			$data['SbblogVer3']['account_id'] = $sAccountID;
			$data['SbblogVer3']['log_date'] = $sDate;
			$this->SbblogVer3->id = $data['SbblogVer3']['id'] = $sAccountID.'_'.$sDate;
			$saveResult = $this->SbblogVer3->save($data);
			if(!$saveResult) throw new Exception('save error');
			$res = "0";

		} catch (Exception $e) {
			$res = "1\t".$e->getMessage();
		}
		echo $res;
		exit;
	}

	/**
	 * テスト用 指定の日付のsbblogをアップデート
	 */
	function sbblogUpdate($pid,$slogdate){
		$path = PATH_LOG.sprintf("%03d",$pid).DS.$slogdate.".log";
		$this->_sbblogupdate($pid,$slogdate,$path);
		exit;
	}
	
	/**
	 * Dclogの保存
	 */
	
	function _dclogupdate($slogdate,$filename){
		$this->_updatelogs("dc",$slogdate,$filename);
	}
	
	/**
	 * Dclogの保存
	 */
	
	function _iglogupdate($slogdate,$filename){
		$this->_updatelogs("ig",$slogdate,$filename);
	}
	
	/**
	 * Cglogの保存
	 */
	function _cglogupdate($slogdate,$filename){
		$this->_updatelogs("cg",$slogdate,$filename);
	}
	
	function _updatelogs($type,$slogdate,$filename){
		echo "<h2>ログアップロード</h2>";
		$i = 0;
		$debug = true;
		$chk_bom = check_bom($filename);
		if($chk_bom){
			var_dump($chk_bom);
			$readfile = str_replace('.log','.log.txt',$filename);
			echo $readfile;
			if(copy($filename,$readfile)){
				$filename = $readfile;
				require_once(APP."vendors".DS."MBConvertEncodingStreamWrapper.php");
				stream_wrapper_register('mbconv', 'MBConvertEncodingStreamWrapper');
				$fp = fopen("mbconv://UTF-8:UTF-16LE:".$filename,"r");
			}
		}else{
			$fp = fopen($filename,"r");
		}
		if(!$fp) return false;
		
		//テンポラリファイル名
		$temp_file = TMP.$type."_".time()."_backuplog.tmp";
		
		$fp_temp = fopen($temp_file,"w");
		
		while(!feof($fp)){
			//1行取得
			$w = fgets($fp);
			//先頭行はBOM削除
			if (ord($w{0}) == 0xef && ord($w{1}) == 0xbb && ord($w{2}) == 0xbf) {
		        $w = substr($w, 3);
		    }
			if($i < $line && $line != 0){
				//読み飛ばし
			}else{
				if($fp_temp){
					fwrite($fp_temp,$w);
				}else{
					$buffer[$i] = $w;
				}
				//echo $i." ".$w."<br>";
			}
			$i++;
		}
		if($fp_temp){
			fclose($fp_temp);
			$file = file($temp_file);
			unlink($temp_file);
		}
		
		$this->log("file({$filename})");
		switch($type){
			case "dc":
				$model = "DclogVer3";
			break;
			case "ig":
				$model = "IglogVer3";
			break;
			case "cg":
				$model = "CglogVer3";
			break;
		}
		set_time_limit(0);
		echo "<h2>{$filename}</h2>";
		echo "行数:".count($file)."<br>";
		//全体
		$i = preg_grep("/^i/",$file);
		$j = preg_grep("/^j/",$file);
		$F = preg_grep("/^F/",$file);
		$E = preg_grep("/^E/",$file);
		$W = preg_grep("/^W/",$file);
		
		
		$this->savedata[$model]['id'] = $slogdate;
		$this->savedata[$model]['count_i'] = count($i);
		$this->savedata[$model]['count_j'] = count($j);
		$this->savedata[$model]['count_F'] = count($F);
		$this->savedata[$model]['count_E'] = count($E);
		$this->savedata[$model]['count_W'] = count($W);
		$this->savedata[$model]['log_date'] = $slogdate;
		$this->{$model}->id = $slogdate;
		$this->$model->save($this->savedata);
		print_r($this->savedata);
		exit;
	}
	
	/* ログデータ更新用 */
	
	function update_logfiles($pid){
		set_time_limit(0);
		$list = null;
		$logdirpath = PATH_LOG.sprintf("%03d",$pid).DS;
		if(is_dir($logdirpath)){
			$dir = opendir($logdirpath);
			while (false !== ($file = readdir($dir))) {
					if ($file != "." && $file != ".." && preg_match("|^\d{8}\.log$|",$file)) {
							$list[] = $file;
					}
			}
			closedir($dir);
		}
		$this->set("list",$list);
		$this->set("logdirpath",$logdirpath);
		$this->set("pid",$pid);
	}
	
	function update_all_service_logfiles(){
		set_time_limit(0);
		$list = null;
		$list2 = null;
		$logdirpath = PATH_LOG."SBR-DC";
		if(is_dir($logdirpath)){
			$dir = opendir($logdirpath);
			while (false !== ($file = readdir($dir))) {
					if ($file != "." && $file != ".." && preg_match("|^\d{8}\.log$|",$file)) {
							$list[] = str_replace(".log","",$file);
					}
			}
			closedir($dir);
		}
		$logdirpath = PATH_LOG."SBR-IG";
		if(is_dir($logdirpath)){
			$dir = opendir($logdirpath);
			while (false !== ($file = readdir($dir))) {
					if ($file != "." && $file != ".." && preg_match("|^\d{8}\.log$|",$file)) {
							$list2[] = str_replace(".log","",$file);
					}
			}
			closedir($dir);
		}
		$logdirpath = PATH_LOG."SBR-CG";
		if(is_dir($logdirpath)){
			$dir = opendir($logdirpath);
			while (false !== ($file = readdir($dir))) {
					if ($file != "." && $file != ".." && preg_match("|^\d{8}\.log$|",$file)) {
							$list3[] = str_replace(".log","",$file);
					}
			}
			closedir($dir);
		}
		if(!empty($list)){
			foreach($list as $l){
				$path = "http://".SBSIP."/api/uploadlog_idc_gss/sbr-dc/?date=".$l;
				echo $path."<br>";
				file_get_contents($path);
			}
		}
		if(!empty($list2)){
			foreach($list2 as $l){
				$path = "http://".SBSIP."/api/uploadlog_idc_gss/sbr-ig/?date=".$l;
				echo $path."<br>";
				file_get_contents($path);
			}
		}
		if(!empty($list3)){
			foreach($list3 as $l){
				$path = "http://".SBSIP."/api/uploadlog_idc_gss/sbr-cg/?date=".$l;
				echo $path."<br>";
				file_get_contents($path);
			}
		}
		exit;
	}
	
	function update_all_logfiles($pid,$roop = null){
		set_time_limit(0);
		$logdirpath = PATH_LOG.sprintf("%03d",$pid).DS;
		if(is_dir($logdirpath)){
			$dir = opendir($logdirpath);
			while (false !== ($file = readdir($dir))) {
					if ($file != "." && $file != ".." && preg_match("|^\d{8}\.log$|",$file)) {
							$list[] = str_replace(".log","",$file);
					}
			}
			closedir($dir);
		}
		if(!empty($list)){
			foreach($list as $l){
				$path = "http://".SBSIP."/api/uploadlog_gss/{$pid}/?date=".$l;
				echo $path."<br>";
				file_get_contents($path);
			}
		}
		if(empty($roop)){
			exit;
		}
	}
	
	function update_all_accounts_logfiles(){
		set_time_limit(0);
		$accounts = $this->Account->findAll();
		foreach($accounts as $a){
			$pid = sprintf("%03d",$a['Account']['ACCOUNT_ID']);
			echo $pid." complete<br>";
			$this->update_all_logfiles($pid,1);
		}
		exit;
	}
	
	function _ereg_folder($dir){
		//sbblogとそろえる
		switch($dir){
			case "dt":
				$dir = "[a-zA-Z]:".DS."Documents and Settings".DS."[^\\]+".DS."デスクトップ";
			break;
			case "md":
				$dir = "[a-zA-Z]:".DS."Documents and Settings".DS."[^\\]+".DS."My Documents";
			break;
			case "wm":
				$dir = "Local Settings".DS."Temp".DS."WM|Application Data".DS."SBC".DS."WM";
				
			break;
			case "oe":
				$dir = "Local Settings".DS."Temp".DS."OE|Application Data".DS."SBC".DS."OE|[A-Za-z]:".DS."Documents and Settings".DS."[^\\]+".DS."Local Settings".DS."Application Data".DS."Identities".DS."[^\\]+".DS."Microsoft".DS."Outlook Express";
			break;
			case "ol":
				$dir = "Local Settings".DS."Temp".DS."OL|Application Data".DS."SBC".DS."OL|[A-Za-z]:".DS."Documents and Settings".DS."[^\\]+".DS."Local Settings".DS."Application Data".DS."Identities".DS."[^\\]+".DS."Microsoft".DS."Outlook ";
				//[todo]Outlookのログ処理
			break;
			case "bk":
				$dir = "[a-zA-Z]:".DS."Becky|Local Settings".DS."Temp".DS."BK|\!\!\!\!Inbox|Application Data".DS."SBC".DS."BK";
			break;
			case "fa":
				$dir = "[a-zA-Z]:".DS."Documents and Settings".DS."[^\\]+".DS."Favorites";
			break;
			case "ff":
				$dir = "Application Data".DS."Mozilla".DS."Firefox";	
			break;
			case "tb":
				$dir = "Application Data".DS."Thunderbird";
			break;
		}
		return $dir;
	}
	
	function chk_folder($from_folder,$folderArr,$kind){
		$ret = NULL;
		reset($folderArr);
		while(list($n,$v) = each($folderArr)){
			
			$dir = $this->_ereg_folder($v);
			
			$ereg = str_replace("\\","\\\\",$dir);
			//$ereg = addslashes($dir);
			$this->debug = true;
			if($this->debug == true){
				//echo "★チェック $from_folder<br>";
				//echo "ereg ".$ereg."<br>";
			}
			if(mb_eregi($ereg,$from_folder,$w)){
				$this->savedata['SbblogdetailVer3'][$v]['count_'.$kind]++;
				$ret = "count_".$v.":".$kind."=".$this->savedata['SbblogdetailVer3'][$v]['count_'.$kind]."<br>";
			}
		}
		reset($folderArr);
		return $ret;
	}
	
	function _sbblogGrep($account_id,$slogdate,$filename,$debug=NULL,$line=0){
		set_time_limit(0);
		$account_id = sprintf("%03d",$account_id);
		$chk_bom = check_bom($filename);
		
		echo "BOM :";
		var_dump($chk_bom);
		
		echo "<br>";
		
		if($chk_bom){
			require_once(APP."vendors".DS."MBConvertEncodingStreamWrapper.php");
			stream_wrapper_register('mbconv', 'MBConvertEncodingStreamWrapper');
			$fp = fopen("mbconv://UTF-8:UTF-16LE:".$filename,"r");
		}else{
			$fp = fopen($filename,"r");
		}
		
		if(!$fp){
			return false;
		}
		$i = 0;
		if(!mb_eregi("[0-9]*",$line)){
			$line = 0;
		}
		$this->log($line."行読み飛ばしする ------------");
		
		//テンポラリファイル名
		$temp_file = TMP.$account_id."_".time()."_backuplog.tmp";
		
		$fp_temp = fopen($temp_file,"w");
		
		//オープン失敗
		if(!$fp_temp){
			
		}
		echo "<br>".$line."行読み飛ばしする ------------<br><br>";
		while(!feof($fp)){
			//1行取得
			$w = fgets($fp);
			//先頭行はBOM削除
			if (ord($w{0}) == 0xef && ord($w{1}) == 0xbb && ord($w{2}) == 0xbf) {
		        $w = substr($w, 3);
		    }
			if($i < $line && $line != 0){
				//読み飛ばし
			}else{
				if($fp_temp){
					fwrite($fp_temp,$w);
				}else{
					$buffer[$i] = $w;
				}
				//echo $i." ".$w."<br>";
			}
			$i++;
		}
		if($fp_temp){
			fclose($fp_temp);
			$file = file($temp_file);
			unlink($temp_file);
		}else{
			$file = $buffer;
		}
		$this->log("読み込みファイル : ".$filename);
		$this->log("行数 : ".count($file));
		
		$this->savedata['SbblogVer3']['id'] = $account_id."_".$slogdate;
		$this->savedata['SbblogVer3']['log_date'] = $slogdate;
		$this->SbblogVer3->id = $this->savedata['SbblogVer3']['id'];
		
		//カウント数初期化
		$sbblog_current = $this->SbblogVer3->find("SbblogVer3.id = '{$account_id}_{$slogdate}'");
		
		if(empty($sbblog_current) or empty($line)){
			$this->savedata['SbblogVer3']['count_i'] = 0;
			$this->savedata['SbblogVer3']['count_j'] = 0;
			$this->savedata['SbblogVer3']['count_F'] = 0;
			$this->savedata['SbblogVer3']['count_E'] = 0;
			$this->savedata['SbblogVer3']['count_W'] = 0;
			$this->log("ログカウント初期化 ALL 0");
		}else{
			$this->savedata['SbblogVer3']['count_i'] = $sbblog_current['SbblogVer3']['count_i'];
			$this->savedata['SbblogVer3']['count_j'] = $sbblog_current['SbblogVer3']['count_j'];
			$this->savedata['SbblogVer3']['count_F'] = $sbblog_current['SbblogVer3']['count_F'];
			$this->savedata['SbblogVer3']['count_E'] = $sbblog_current['SbblogVer3']['count_E'];
			$this->savedata['SbblogVer3']['count_W'] = $sbblog_current['SbblogVer3']['count_W'];
			$this->log("SbblogVer3 ログカウント追加 
			　i : {$this->savedata['SbblogVer3']['count_i']} + 今回の値
			　j : {$this->savedata['SbblogVer3']['count_j']} + 今回の値
			　F : {$this->savedata['SbblogVer3']['count_F']} + 今回の値
			　E : {$this->savedata['SbblogVer3']['count_E']} + 今回の値
			　W : {$this->savedata['SbblogVer3']['count_W']} + 今回の値
			");
		}
		
		
		//全体
		$i = preg_grep("/^i\t.*$/i",$file);
		$this->savedata['SbblogVer3']['count_i'] += count($i);
		$j = preg_grep("/^j\t.*$/i",$file);
		$this->savedata['SbblogVer3']['count_j'] += count($j);
		$F = preg_grep("/^F\t.*$/i",$file);
		$this->savedata['SbblogVer3']['count_F'] += count($F);
		$E = preg_grep("/^E\t.*$/i",$file);
		$this->savedata['SbblogVer3']['count_E'] += count($E);
		$W = preg_grep("/^W\t.*$/i",$file);
		$this->savedata['SbblogVer3']['count_W'] += count($W);
		
		//fileはいらないので開放
		$file = NULL;
		unset($file);
		
		echo "<h3>Sbblogに保存する</h3>";
		//$this->savedata['SbblogVer3']['count_i'] += $this->savedata['SbblogVer3']['count_j'];
		//$this->savedata['SbblogVer3']['count_i'] += $this->savedata['SbblogVer3']['count_F'];
		$this->SbblogVer3->save($this->savedata);
		echo "<pre>";
		var_dump($this->savedata['SbblogVer3']);
		echo "</pre>";
		//echo "<hr>";
		
		//各フォルダ
		$folderArr["md"] = "md";
		$folderArr["dt"] = "dt";
		$folderArr["oe"] = "oe";
		$folderArr["fa"] = "fa";
		$folderArr["wm"] = "wm";
		$folderArr["bk"] = "bk";
		$folderArr["ff"] = "ff";
		$folderArr["tb"] = "tb";
		$folderArr["ol"] = "ol";
		
		$entry_nums["md"] = 0;
		$entry_nums["dt"] = 1;
		$entry_nums["oe"] = 2;
		$entry_nums["fa"] = 3;
		$entry_nums["wm"] = 20;
		$entry_nums["bk"] = 30;
		$entry_nums["ff"] = 9;
		$entry_nums["tb"] = 10;
		$entry_nums["ol"] = 40;
		
		$sbbconf = $this->Sbbconf->findAll("Sbbconf.ACCOUNT_ID = '{$account_id}' and ( (Sbbconf.CONF_ENTRY_NUM > 3 and Sbbconf.CONF_ENTRY_NUM < 9) or (Sbbconf.CONF_ENTRY_NUM > 49) )","*");
		
		//echo "<h2>調べるフォルダ</h2>";
		foreach($sbbconf as $s){
			
			$entry_num = $s['Sbbconf']['CONF_ENTRY_NUM'];
			$folder = ($s['Sbbconf']['CONF_FROM_FOLDER']);
			if(!empty($folder)){
				//echo $folder."<br>";
				$entry_nums[$folder] = sprintf("%03d",$entry_num);
				$folderArr[$folder] = $folder;
			}
		}
		
		//$test_grep = $F;
		//echo "GREPカウント<br>".count($test_grep)."<br>";
		foreach($folderArr as $f){
			$this->savedata['SbblogdetailVer3'] = NULL;
			$name_grep = $f;
			$grep = $this->Sbblog->folder2grep($name_grep);
			//echo $f."<br>".$grep."<br>";
			//$test_grep = preg_grep("/{$grep}/i",$test_grep,PREG_GREP_INVERT);
			
			//echo "GREPして残ったカウント";
			//echo "<br>rest_count: ";var_dump(count($test_grep));echo "<br>";
			
			
			//id
			$this->savedata['SbblogdetailVer3']['id'] = $account_id."_".$slogdate."_".sprintf("%03d",$entry_nums[$f]);
			//echo "<br>logid ".$this->savedata['SbblogdetailVer3']['id']."<br>";
			$this->savedata['SbblogdetailVer3']['folder'] = $f;
			$this->savedata['SbblogdetailVer3']['name'] = $f;
			$this->savedata['SbblogdetailVer3']['entry_num'] = $entry_nums[$f];
			
			$sbblogdetail_current = $this->SbblogdetailVer3->find("SbblogdetailVer3.id = '{$this->savedata['SbblogdetailVer3']['id']}'");
			//var_dump($sbblogdetail_current);
			if(empty($sbblogdetail_current) or empty($line)){
				$this->savedata['SbblogdetailVer3']['count_i'] = 0;
				$this->savedata['SbblogdetailVer3']['count_j'] = 0;
				$this->savedata['SbblogdetailVer3']['count_F'] = 0;
				$this->savedata['SbblogdetailVer3']['count_E'] = 0;
				$this->savedata['SbblogdetailVer3']['count_W'] = 0;
			}else{
				$this->savedata['SbblogdetailVer3']['count_i'] = $sbblogdetail_current['SbblogdetailVer3']['count_i'];
				$this->savedata['SbblogdetailVer3']['count_j'] = $sbblogdetail_current['SbblogdetailVer3']['count_j'];
				$this->savedata['SbblogdetailVer3']['count_F'] = $sbblogdetail_current['SbblogdetailVer3']['count_F'];
				$this->savedata['SbblogdetailVer3']['count_E'] = $sbblogdetail_current['SbblogdetailVer3']['count_E'];
				$this->savedata['SbblogdetailVer3']['count_W'] = $sbblogdetail_current['SbblogdetailVer3']['count_W'];
				$this->log("Sbblogdetail ログカウント追加 
			　i : {$this->savedata['SbblogdetailVer3']['count_i']} + 今回の値
			　j : {$this->savedata['SbblogdetailVer3']['count_j']} + 今回の値
			　F : {$this->savedata['SbblogdetailVer3']['count_F']} + 今回の値
			　E : {$this->savedata['SbblogdetailVer3']['count_E']} + 今回の値
			　W : {$this->savedata['SbblogdetailVer3']['count_W']} + 今回の値
			");
			}
			$this->savedata['SbblogdetailVer3']['count_i'] += count(preg_grep("/{$grep}/i",$i));
			$this->savedata['SbblogdetailVer3']['count_j'] += count(preg_grep("/{$grep}/i",$j));
			$this->savedata['SbblogdetailVer3']['count_F'] += count(preg_grep("/{$grep}/i",$F));
			//var_dump(count(preg_grep("/{$grep}/i",$F)));
			$this->savedata['SbblogdetailVer3']['count_E'] += count(preg_grep("/{$grep}/i",$E));
			$this->savedata['SbblogdetailVer3']['count_W'] += count(preg_grep("/{$grep}/i",$W));
			$this->savedata['SbblogdetailVer3']['log_date'] = $slogdate;
			$this->savedata['SbblogdetailVer3']['account_id'] = $account_id;
			
			/*
			$test = preg_grep("/{$grep}/i",$F);
			$test_folder = NULL;
			while(list($n,$v) = each($test)){
				$test_ex = explode("\t",$v);
				$test_folder[$test_ex[4]] = $test_ex[4];
			}
			if(!empty($test_folder)){
			foreach($test_folder as $t){
				echo "folder:".$t."<br>";
			}
			}
			*/
			$this->SbblogdetailVer3->id = $this->savedata['SbblogdetailVer3']['id'];
			//$this->savedata['SbblogdetailVer3']['count_i'] = $this->savedata['SbblogdetailVer3']['count_i']+$this->savedata['SbblogdetailVer3']['count_j']+$this->savedata['SbblogdetailVer3']['count_F'];
			
			$output_chk = $this->savedata['SbblogdetailVer3'];
			if(!empty($output_chk['count_i']) || !empty($output_chk['count_j']) || !empty($output_chk['count_F']) || !empty($output_chk['count_E']) || !empty($output_chk['count_W'])){
				echo "<h2>{$f}</h2>";
				echo $grep."<br>";
				echo "<h3>Sbblogdetailに保存する logid ".$this->SbblogdetailVer3->id."</h3>";
			echo !empty($this->savedata['SbblogdetailVer3']['count_i'])?"count_i : ".$this->savedata['SbblogdetailVer3']['count_i']."<br>":"";
			echo !empty($this->savedata['SbblogdetailVer3']['count_j'])?"count_j : ".$this->savedata['SbblogdetailVer3']['count_j']."<br>":"";
			echo !empty($this->savedata['SbblogdetailVer3']['count_F'])?"count_F : ".$this->savedata['SbblogdetailVer3']['count_F']."<br>":"";
			echo !empty($this->savedata['SbblogdetailVer3']['count_E'])?"count_E : ".$this->savedata['SbblogdetailVer3']['count_E']."<br>":"";
			echo !empty($this->savedata['SbblogdetailVer3']['count_W'])?"count_W : ".$this->savedata['SbblogdetailVer3']['count_W']."<br>":"";
			}
			
			$this->SbblogdetailVer3->save($this->savedata);
			
			//echo "残ったもの";
			//echo "<pre>";
			//echo "count_F : ".$this->savedata['SbblogdetailVer3']['count_F']."<br>";
			//echo "</pre>";
			//echo "<hr>";
		}
		//echo var_dump($test_grep);;
		return true;
	}
	
	
	/**
	 * Sbblogへの保存
	 */
	
	
	function mysqlupdate(){
		/*
		//todo:mentenanceに移動
		//MEMO項目追加
		$queries[] = "CREATE TABLE `sbb_logdetail` (
			`LOG_ID` bigint(20) NOT NULL auto_increment,
			`ACCOUNT_ID` int(3) NOT NULL default '0',
			`SLOG_DATE` date NOT NULL default '0000-00-00',
			`i` int(11) NOT NULL default '0',
			`E` int(11) NOT NULL default '0',
			`W` int(11) NOT NULL default '0',
			`TYPE` text,
			`FOLDER` text,
			`ENTRY_NUM` int(11) NOT NULL default '0',
			PRIMARY KEY  (`LOG_ID`),
			KEY `ACCOUNT_ID` (`ACCOUNT_ID`,`SLOG_DATE`)
		) TYPE=MyISAM COMMENT='ログ詳細';
		";
		$queries[] = "ALTER TABLE `account` ADD `ACCOUNT_CONFMEMO` TEXT NULL";
		//log詳細を変更
		$queries[] = "ALTER TABLE `sbb_logdetail` DROP `SLOG_TIME` ,
									DROP `SLOG_KIND` ,
									DROP `SLOG_COM` ,
									DROP `SLOG_FROM` ,
									DROP `SLOG_TO` ,
									DROP `SLOG_MASSAGE` ,
									DROP `SLOG_FOLDER` ;";
		$queries[] = "ALTER TABLE `sbb_logdetail` ADD `i` INT NOT NULL DEFAULT '0',
									ADD `E` INT NOT NULL DEFAULT '0',
									ADD `W` INT NOT NULL DEFAULT '0',
									ADD `TYPE` TEXT NULL,
									ADD `FOLDER` TEXT NULL,
									ADD `ENTRY_NUM` INT NOT NULL";
		$queries[] = "ALTER TABLE `sbb_conf` ADD `created` DATETIME NOT NULL;";
		
		//2.0用
		$queries[] = "CREATE TABLE `dc_log` (
									`SLOG_KIND` char(1) NOT NULL default '',
									`SLOG_DATE` date NOT NULL default '0000-00-00',
									`SLOG_COUNT` int(1) NOT NULL default '0',
									KEY `SLOG_KIND` (`SLOG_KIND`,`SLOG_DATE`)
									) TYPE=MyISAM;";
		$queries[] = "CREATE TABLE `ig_log` (
									`SLOG_KIND` char(1) NOT NULL default '',
									`SLOG_DATE` date NOT NULL default '0000-00-00',
									`SLOG_COUNT` int(1) NOT NULL default '0',
									KEY `SLOG_KIND` (`SLOG_KIND`,`SLOG_DATE`)
									) TYPE=MyISAM;";
		$queries[] = "CREATE TABLE `dc_logdetail` (
										`LOG_ID` bigint(20) NOT NULL auto_increment,
										`SLOG_DATE` date NOT NULL default '0000-00-00',
										`i` int(11) NOT NULL default '0',
										`E` int(11) NOT NULL default '0',
										`W` int(11) NOT NULL default '0',
										`TYPE` text,
										`FOLDER` text,
										`ENTRY_NUM` int(11) NOT NULL default '0',
										PRIMARY KEY  (`LOG_ID`),
										KEY `SLOG_DATE` (`SLOG_DATE`)
									) TYPE=MyISAM COMMENT='SBR-DCログ詳細';";
		
		$queries[] = "CREATE TABLE `ig_logdetail` (
										`LOG_ID` bigint(20) NOT NULL auto_increment,
										`SLOG_DATE` date NOT NULL default '0000-00-00',
										`i` int(11) NOT NULL default '0',
										`E` int(11) NOT NULL default '0',
										`W` int(11) NOT NULL default '0',
										`TYPE` text,
										`FOLDER` text,
										`ENTRY_NUM` int(11) NOT NULL default '0',
										PRIMARY KEY  (`LOG_ID`),
										KEY `SLOG_DATE` (`SLOG_DATE`)
									) TYPE=MyISAM COMMENT='SBR-IGログ詳細';";
		$queries[] = "ALTER TABLE `account` ADD `CONF_UPDATE` DATETIME NULL ;";
		
		if(!empty($queries)){
			foreach($queries as $query){
				$res = $this->Account->query($query);
				echo "<div>".$query."</div>";
			}
		}
		$this->log("mysqlupdate run");
		*/
		exit;
	}
	
	/**
	 * サイズファイルから任意のデータ抜きだし
	 */
	
	function getSize($pid = 1,$num = "1_idc"){
		$ret = $this->Sbblog->_getUseSize($pid,$num);
		echo "pid : {$pid}  num: {$num} => {$ret}";
		exit;
	}
	
	/**
	 * サイズファイル取得書類書き出し
	 * text[...] = pid,entry_num,path,size
	 */
	
	function exportSizefile(){
		$this->_exportSizefile(true);
	}

	/**
	 * SBL専用
	 */
	function testSBMDAPI() {
		$cmds = array(
			'exportMaintenanceIniFile',
			'exportDUOutAndGssIniFile',
		);
		$outputFormat = 'cmd : %s' . PHP_EOL . 'res : %s' . PHP_EOL . PHP_EOL;
		foreach($cmds as $cmd) {
			$res = $this->fromSBMD($cmd);
		}
	}
	function fromSBMD($cmd) {
		set_time_limit(300);
		header('Content-Type: text/plain;');
		$cmd = '_' . $cmd;
		if(method_exists($this, $cmd)) {
			$res = $this->{$cmd}();
			if($res === true) {
				echo '0' . PHP_EOL;
			} else {
				echo '1' . PHP_EOL;
			}
		} else {
			echo "1" . PHP_EOL . 'parameter error' . PHP_EOL . $cmd;
		}
	}
	function _exportMaintenanceIniFile() {
		return $this->_updateMaintenanceIniFile(true, false);
	}
	function _exportDUOutAndGssIniFile() {
		return $this->_exportSizefile(false, false);
	}
	
	function verchk(){
		$ret = "NULL";
		$versionfile = "C:".DS."RI".DS."MS07S".DS."rev".DS."history.txt";
		if(file_exists($versionfile)){
			//SBMversionがあればそこからversionを取り出す
			$fp = file($versionfile);
			if(!empty($fp[0])){
				$w = explode("\t",$fp[0]);
				if(count($w)>1){
					$ret = $w[0];
				}
			}
		}
		echo $ret;
		exit;
	}
	
	function auth(){
		header("Content-type: text/plain;");
		echo "0,".MASTERKEY."\r\n411001\r\nldicgv";
		exit;
	}
	
	function returnsbsinfo(){
		
	}
	
	function getdatacenterusesize(){
		$this->layout = false;
		$original = ini_get("default_socket_timeout");
		ini_set("default_socket_timeout",3); 
		$url = "http://".IDC_IP."/api/get_user_size/".UID."/".$_SERVER['SERVER_ADDR'];
		$res = @file_get_contents($url);
		
		ini_set("default_socket_timeout",$original);
		if($res){
			if(ereg("false|error",$res)){
				echo "データセンタから使用量が取得できませんでした"; //[error:]
			}else{
				$w = explode("\r\n",$res);
				$size['update'] = $w[0];
				$size['use_size'] = $w[1];
				$size['free_per'] = $w[2];
				$size['use_per'] = 100 - $w[2];
				$size['quota'] = $w[3];
				$size['free_space'] = ($w[3]*1024*1024*1024)-$w[1];
				$this->set("size",$size);
				return $this->render();
			}
		}else{
			echo "データセンタに接続できませんでした。"; //[error:]
		}
		exit;
	}
	
	function reg_restorelog(){
		
	}

	function sbeError(){
		$chk = $this->_tableExistsAndCreate('sbelog');
		$datetime = date('Y-m-d H:i:s');
		$res = $this->Account->query("iinsert into sbelog set created = '{$datetime}';");
		if(!$res){
			echo "0";
		}else{
			echo "100\tデータベースに登録できませんでした";
		}
		exit;
	}
	
	function sbeSuccess(){
		$chk = $this->_tableExistsAndCreate('sbelog');
		$res = $this->Account->query("truncate table sbelog");
		echo "0";
		exit;
	}

	function _tableExistsAndCreate($table) {
		try {
			$sql = "show tables from ms09s_uni like '{$table}'";
			if($res = mysql_query($sql)) {
				$row = mysql_fetch_row($res);
			}
			if(empty($row)) {
				if($this->_createTable($table) === false) {
					throw new Exception($table . ' is not exists.');
				}
			}
			return true;
		} catch (Exception $e) {
			return false;
		}
	}

	function _createTable($table) {
		$sqlFile = PATH_PG_BASE . DS . 'SBM'. DS . 'files' . DS . 'tables' . DS . 'tables' . DS . $table . '.sql';
		if(file_exists($sqlFile)) {
			$sql = implode(file($sqlFile), PHP_EOL);
			if(mysql_query($sql)) {
				$chk = mysql_query("select count(*) from `{$table}`");
				if(!empty($chk)) {
					$res = mysql_fetch_row($chk);
					if(!empty($res) && isset($res[0])) {
						return $res[0];
					}
				}
			}else {
				$error = mysql_error();
			}
		}
		return false;
	}
	
	function sbeErrorCount(){
		$chk = $this->_tableExistsAndCreate('sbelog');
		try {
			if(!$chk) {
				throw new Exception("データベースからの戻り値がなし", 100);
			}
			$res = mysql_query('select count(*) from sbelog');
			if(!empty($res)) {
				$row = mysql_fetch_row($res);
				if(isset($row[0])) {
					$count = $row[0];
				}
			}
			if($res !== false && isset($count)){
			}else{
				throw new Exception("データベースからの戻り値がなし", 100);
			}
			echo "0\t".$count;
		} catch (Exception $e) {
			echo $e->getCode() . "\t" . $e->getMessage();
		}
		exit;
	}
	
	function sbmupdateFromFile(){
		$uploadTo = rtrim(PATH_PG_BASE, DS) . DS ."SecureBackUpdator".DS;
		$sbw_result = false;
		$filename = "updator.zip";
		
		
		$admin = $this->Session->read("Admin");
		if(empty($admin)){
			$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"システムのアップデート","","実行","true");
		}else{
			$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","システムのアップデート","システムのアップデート","実行","true");	
		}
		
		if(!file_exists($uploadTo)){
			mkdir($uploadTo);
		}
		//$upfile = $uploadTo."update";
		
		if(!empty($_FILES['data']['tmp_name']['Update']['file'])){
			
			$type = $_FILES['data']['type']['Update']['file'];
			$name = $_FILES['data']['name']['Update']['file'];
			if(!mb_ereg("zip",$name)){
				$this->Session->setFlash("ファイル形式が違います。");
				$this->redirect("/sbmconf/index/");
				exit;
			}
			
			$copy = move_uploaded_file($_FILES['data']['tmp_name']['Update']['file'],$uploadTo.$filename);
			
			//アップデータチェック
			$updaterPath = rtrim(PATH_PG_BASE, DS) . DS ."SecureBackUpdator".DS. "updator.zip";
			if(file_exists($updaterPath)){
				$chkUpdator = file_get_contents("http://" . SBS_LOCAL_ADDRESS . ":".SBW_PORT."/checkUpdator/");
				if($chkUpdator == 0){
					//正しいZIP
				}else{
					//間違ったZIP
					$this->Session->setFlash("不正なアップデータです。");
					unlink($updaterPath);
					$this->redirect("/sbmconf/index/");
					exit;
				}
			}else{
				//そもそもアップデータがない
				$this->Session->setFlash("アップデータが存在しませんでした。");
				$this->redirect("/sbmconf/index/");
				exit;
			}
			
			//現在のversion
			$file = APP."..".DS."rev".DS."history.txt";
			if(file_exists($file)){
				$txt = file($file);
				if(!empty($txt[0])){
					$history = explode("\t",$txt[0]);
					$data['version'] = $history[0];
				}
			}
			$admin = $this->Session->read("Admin");
			if(empty($admin)){
				$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"システムのアップデート","バージョン={$data['version']}","実行","true");
			}else{
				$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","システムのアップデート","システムのアップデート","実行","true");	
			}
			
			//update.txt
			$fp = fopen(APP."config".DS."SBMupdate.txt","w");
			$date = date("Y-m-d H:i:s");
			$res = fwrite($fp,$date);
			fclose($fp);
			
			if($copy){
				//[todo]SBWを叩いて実行
				$sbw_result = true;
				//echo "http://" . SBS_LOCAL_ADDRESS . "/update_sbs/?=".urlencode($uploadTo.$filename);
				//exit;
				//if(!defined("TESTMACHINE")){
					
					$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
					if (!$fs) { 
						$this->log("fsockopen Error: $errstr ($errno)<br>\n");
					} else { 
						socket_set_blocking($fs, false); 
						fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/update_sbs/ HTTP/1.0\r\n\r\n"); 
						fclose ($fs); 
					}
					
				//}
			}
			
			if($sbw_result === false){
				$this->Session->setFlash("アップデートできませんでした。<br>アップデートファイルが正しいか確認してください。");
				$this->redirect("/sbmconf/index/");
				exit;
			}
			
			//以下アップデート画面用
					
			$this->layout = "update";
			$this->pageTitle = "システムのアップデート";
			
			$second = "900";
			$this->set("second",$second);
			$url = $_SERVER['REQUEST_URI'];
			$redirecturl = str_replace("api/sbmupdateFromFile","account/index",$url);
			
			$data['Admin']['ADMIN_LOGIN'] = NULL;
			$data['Admin']['id'] = 1;
			$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
			$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
			$this->Admin->id=1;
			$this->Admin->save($data,false);
			$this->Session->del("Admin");
			header('Refresh: '.$second.';URL='.$redirecturl);
			$this->set("redirecturl",$redirecturl);
		
			return $this->render("systemupdate");
		}
		
	}

	function update_test(){
		//以下アップデート画面用
		$this->layout = "update";
		$this->pageTitle = "システムのアップデート";
		$this->render("systemupdate");
	}
	
	function sbw_update(){
			//アップデータチェック
			if(file_exists(rtrim(PATH_PG_BASE, DS) . DS ."SecureBackUpdator".DS."updator.zip")){
				$chkUpdator = file_get_contents("http://" . SBS_LOCAL_ADDRESS . ":".SBW_PORT."/checkUpdator/");
				if($chkUpdator == 0){
					//正しいZIP
					//unlink(PATH_PG_BASE."gss".DS."bin".DS."LocalLog.ini");
				}else{
					//間違ったZIP
					$this->Session->setFlash("不正なアップデータです。");
					unlink(rtrim(PATH_PG_BASE, DS)."SecureBackUpdator".DS."updator.zip");
					$this->redirect("/sbmconf/index/");
					exit;
				}
			}else{
				//そもそもアップデータがない
				$this->Session->setFlash("アップデータが存在しませんでした。");
				$this->redirect("/sbmconf/index/");
				exit;
			}
			
			
			//現在のversion
			$file = APP."..".DS."..".DS."rev".DS."history.txt";
			if(file_exists($file)){
				$txt = file($file);
				if(!empty($txt[0])){
					$history = explode("\t",$txt[0]);
					$data['version'] = $history[0];
				}
			}
			
			//SBWにて実行
			
			$fs = fsockopen(SBS_LOCAL_ADDRESS, SBW_PORT, $errno, $errstr, 5); 
			if (!$fs) { 
				$this->log("fsockopen Error: $errstr ($errno)<br>\n");
			} else { 
				socket_set_blocking($fs, false); 
				fputs ($fs, "GET "."http://" . SBS_LOCAL_ADDRESS . "/update_sbs/ HTTP/1.0\r\n\r\n"); 
				fclose ($fs); 
			}
			
			//以下アップデート画面用
				
			$this->layout = "update";
			$this->pageTitle = "システムのアップデート";
			
			//オペログ登録
			$admin = $this->Session->read("Admin");
			if(empty($admin)){
				$this->Actionlog->reg("0",null,$_SERVER['REMOTE_ADDR'],"システムのアップデート","バージョン={$data['version']}","実行","true");
			}else{
				$this->Actionlog->reg($admin['ADMIN_ID'],null,"Secure Back Manager管理者","システムのアップデート","システムのアップデート","実行","true");	
			}
			
			//update.txt
			$fp = fopen(APP."config".DS."SBMupdate.txt","w");
			$date = date("Y-m-d H:i:s");
			$res = fwrite($fp,$date);
			fclose($fp);
			
			//wait
			
			$data['Admin']['ADMIN_LOGIN'] = NULL;
			$data['Admin']['id'] = 1;
			$data['Admin']['ADMIN_LOGIN_STATUS'] = 0;
			$data['Admin']['ADMIN_SESSION_END'] = date("Y-m-d H:i:s");
			$this->Admin->id=1;
			$this->Admin->save($data,false);
			$this->Session->del("Admin");
			$this->Session->del("SBM");
		
			$this->render("systemupdate");
			
			//[todo]
			//アップデート画面はコマンド発行後にページ繊維する
			//SBWはコマンドを受け付けてからアップデート実行までに猶予ととり
			//ページ遷移ができるようにしておく
		
	}
	
	
	//{親鍵},{バックアップ先},ms09
	function sbnrestore(){
		header("Content-type: text/plain;");
		$returnParams = '%s,%s,MS09,%s,%s';
		$drives = $this->MaintenanceSchedule->getSettingDrivesText();
		$accountDrives = $this->Account->getBackupDrives();
		$prefix = '';
		if(!empty($accountDrives)) {
			if(!empty($drives)) {
				$prefix = ';';
			}
			foreach($accountDrives as $w) {
				if($w != PATH_BACKUP) {
					$tmp[] = $w;
				}
			}
			if(!empty($tmp)) {
				$drives .= $prefix. implode($tmp, ';');
			}
		}
		$return = sprintf($returnParams,SBS_ID,PATH_BACKUP,PATH_LOG.'SBN',$drives);
		echo $return;
		exit;
	}
	
	function addUser(){
		$filename = APP."config".DS."addUser.csv";
		$logfilename = APP."config".DS."addUser.log";
		
		if($fp = fopen($logfilename,"a")){
		}
		if(file_exists($filename)){
			header("Content-type: text/plain;");
			echo $filename."\r\n\r\n";
			$chk_bom = check_bom($filename);
			$read = file($filename);
			$count = count($read);
			if($count > 0){
				$j = 1;
				for($i=0;$i<$count;$i++){
					//初期化
							
					if($chk_bom){
						$read[$i] = mb_convert_encoding($read[$i],"UTF-8","UTF-16LE");
					}else{
						$read[$i] = mb_convert_encoding($read[$i],"UTF-8","SJIS-win");
					}
					if(!mb_ereg("^#",$read[$i])){
						if(!mb_eregi("\t|\\\"|\\\'",$read[$i])){
							$exp = explode(",",$read[$i]);
							if(count($exp) > 1 or !mb_ereg("^$",$exp[0])){
								echo sprintf("%03d",$j)." : ".$exp[0]."\r\n";
								$this->Account->id = $j;
								$this->data['Account'] = NULL;
								$this->data['Account']['ACCOUNT_ID'] = $j;
								if(!empty($exp[0])) $this->data['Account']['ACCOUNT_LOGIN_ID'] = $exp[0];
								if(!empty($exp[1])) $this->data['Account']['ACCOUNT_PASSWORD'] = $exp[1];
								if(!empty($exp[2])) $this->data['Account']['ACCOUNT_QUOTA'] = $exp[2];
								if(!empty($exp[3])) $this->data['Account']['ACCOUNT_BANDWIDTH'] = $exp[3];
								$this->Account->save($this->data);
								if(isset($this->data['Account']['ACCOUNT_QUOTA'])){
									$res = $this->Cmd->updateAccount($j, $this->data['Account']['ACCOUNT_QUOTA'],-1);
								}
							}
							$j++;
						}else{
							echo sprintf("%03d",$j)." : \r\n";
							$err[$i] = date("Y-m-d H:i:s")."\t".sprintf("%03d",$j)."\tタブまたはクォーテーションを含んでいます\t登録できませんでした\r\n";
							$j++;
						}
					}
				}
			}
			if($fp){
				if(!empty($err)){
					fwrite($fp,date("Y-m-d H:i:s")."\tadduserを実行(ファイル名:".$filename.")\r\n");
					fwrite($fp,implode($err));
				}
				fclose($fp);
			}
			$this->Cmd->_exec_bat();
			//unlink($filename);
		}
	}
	/**
	 * パスワード変更登録
	 */
	function changePw($aid,$temporaryPw){
		//sanitize
		$retval = "1";
		$message = "";
		
		$aid = (int)$aid;
		if(!empty($aid)){
			$aid = sprintf("%03d",$aid);
			$pw = addslashes($temporaryPw);
			$newpw = addslashes($_GET['newpw']);
			
			//ログイン
			$data = $this->Account->find("Account.ACCOUNT_ID = '{$aid}'");
			$res = $this->Api->login($data,$pw);
			
			//入力チェックOKなら
			if($res['ret'] == 0){
				$savedata['Account']['ACCOUNT_ID'] = $aid;
				$this->Account->id = $aid;
				if(empty($newpw)){
					$error["empty"] = "パスワードが空です";
				}
				if($newpw == $data['Account']['ACCOUNT_PASSWORD']){
					$error["str"] = "パスワードを変更してください";
				}
				if(strlen($newpw) > 255){
					$error["str"] = "255文字以内で登録してください";
				}
				if(mb_ereg('[\\\\\"\'”’￥]',$newpw)){
					$error["str"] = "次の記号(\'\"\\)は利用できません:半角/全角共に";
				}
				
				if(empty($error)){
					$pwdate = date("Y-m-d H:i:s");
					$save = $this->Account->saveField("ACCOUNT_PASSWORD",$newpw);
					$save = $this->Account->saveField("ACCOUNT_PW_DATE",$pwdate);
					$newdate = $this->Account->getPwLimitDate($pwdate,$data);
					//echo $newpw;
					$retval = "0,".$newdate;
					$message = "";
				}else{
					$retval = "1";
					$message = implode($error,"");
				}
				
			}else{
				$message = "\tログインに失敗しました";
			}
			
		}
		echo $retval.$message;
		exit;
	}
	
	/**
	 * ログインチェックAPI
	 */
	
	function loginChk($id = NULL){
		$pw = NULL;
		$loginid = NULL;
		
		if(!empty($_GET['pw'])){
			$pw = urlencode($_GET['pw']);
		}
		
		if(!empty($_GET['id'])){
			$loginid = urldecode($_GET['id']);
		}
		
		header("Content-type: text/plain;");
		echo "★APIテスト"." id=".$id." pw=".$_GET['pw']." loginid=".$loginid."\r\n";
		#api/login
		echo "\r\napi/login ログイン\r\n";
		
		
		echo "\r\n----------------------------------------------------------------------\r\n";
		
		if(!empty($id)){
			$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/login/".$id."/?pw=".$pw;
		}elseif(!empty($loginid)){
			$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/login/0/?pw=".$pw."&id=".urlencode($loginid);
		}
		
		if(!empty($url)){
			echo "■API => ".$url."\r\n";
			$res = file_get_contents($url);
			echo "\r\n結果＞＞\r\n\r\n";
			echo($res);
			echo "\r\n\r\n＜＜結果\r\n\r\n";
			if(mb_ereg("id=([a-zA-Z0-9]+)",$res,$match)){
				if(!empty($match[1])){
					$id = $match[1];
				}
			}
			if(mb_ereg("temporarypw=([a-zA-Z0-9]+)",$res,$match)){
				if(!empty($match[1])){
					$tpw = $match[1];
					echo "テンポラリパスワード = ".$tpw."\r\n";
					
					echo "\r\n----------------------------------------------------------------------\r\n";
					echo "■テンポラリパスワードでのログイン\r\n";
					$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/login/".$id."/?pw=".$tpw;
					echo $url;
					echo "API => ".$url."\r\n";
					$res = file_get_contents($url);
					echo "\r\n結果＞＞\r\n\r\n";
					echo $res;
					echo "\r\n\r\n＜＜結果\r\n\r\n";
					
					echo "\r\n----------------------------------------------------------------------\r\n";
					
					echo "■テンポラリパスワードでのgetconfdate\r\n";
					$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/getconfdate/".$id."/?pw=".$tpw;
					echo $url;
					echo "API => ".$url."\r\n";
					$res = file_get_contents($url);
					echo "\r\n結果＞＞\r\n\r\n";
					echo $res;
					echo "\r\n\r\n＜＜結果\r\n\r\n";
					
					echo "\r\n----------------------------------------------------------------------\r\n";
					
					echo "■テンポラリパスワードでのgetinfo\r\n";
					$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/getinfo/".$id."/?pw=".$tpw;
					echo $url;
					echo "API => ".$url."\r\n";
					$res = file_get_contents($url);
					echo "\r\n結果＞＞\r\n\r\n";
					echo $res;
					echo "\r\n\r\n＜＜結果\r\n\r\n";
					
					echo "\r\n----------------------------------------------------------------------\r\n";
					
					echo "■テンポラリパスワードでのgetconf\r\n";
					$url = "http://" . SBS_LOCAL_ADDRESS . ":".HTTP_PORT."/api/getconf/".$id."/?pw=".$tpw;
					echo $url;
					echo "API => ".$url."\r\n";
					$res = file_get_contents($url);
					echo "\r\n結果＞＞\r\n\r\n";
					echo $res;
					echo "\r\n\r\n＜＜結果\r\n\r\n";
				}
			} 
		}
		
		echo "\r\n----------------------------------------------------------------------\r\n";
		
		#api/getconf
		#api/getconfdate
		#api/getinfo
		
		exit;
	}

    /**
     * 各ファイルのバージョンをチェック
     */
    function allVersionChk(){
        header('Content-Type: text/plain;');
        $sbw = PATH_PG_BASE.'SBWService'.DS.'SBWService.exe';
		$gss = PATH_PG_BASE.'gss'.DS.'bin'.DS.'GIGA Sonic Service.exe';
		$sbr = PATH_PG_BASE.'SBRService'.DS.'bin'.DS.'Secure Back Client.exe.disable';
        
		$cmd['sbw'] = sprintf('filever %s',$sbw);
		echo $cmd['sbw'];
		echo PHP_EOL;
		var_dump($this->Cmd->_exec($cmd['sbw']));
		exit;
    }

	/**
	 * メンテナンス機能用
	 */
	
	function get_maintenance_info(){
		//Configure::write('debug', 2);
		$this->layout = false;
		header('Content-type: text/plain;');
		$row = $this->MaintenanceSchedule->find('all', array(
			'conditions' => array(
				"MaintenanceSchedule.isActive = '1'"
			),
			'order' => array(
				'id' => 'asc'
			)
		));
		if(!empty($row)){
			$i = 1;
			$this->Maintenance->setActiveUsers($this->MaintenanceSchedule->_getActiveUsers());
			foreach($row as $index => $w){
				$m = $w['MaintenanceSchedule'];
				$taskNo = 'Task' . $i;
				$className = $m['ClassName'];
				$userList = $this->Maintenance->updateUserList($w);
				if(empty($userList) && $m['target'] != 'all') {
					continue;
				}
				$data[$taskNo] = $m;
				if(mb_eregi("^\\\\\\\\([^\\\\]+)",$m['dstDrive'],$match)){
					$host = @$match[1];
					if(!empty($m['dstDriveUsername'])){
						$data[$taskNo]['dstDriveUsername'] = $host."\\".$m['dstDriveUsername'];
					}
				}
				if(mb_eregi("^\\\\\\\\([^\\\\]+)",$m['dstDrive1st'],$match)){
					$host = @$match[1];
					if(!empty($m['dstDrive1stUsername'])){
						$data[$taskNo]['dstDrive1stUsername'] = $host."\\".$m['dstDrive1stUsername'];
					}
				}
				if(mb_eregi("^\\\\\\\\([^\\\\]+)",$m['dstDrive2nd'],$match)){
					$host = @$match[1];
					if(!empty($m['dstDrive2ndUsername'])){
						$data[$taskNo]['dstDrive2ndUsername'] = $host."\\".$m['dstDrive2ndUsername'];
					}
				}
				if(mb_eregi("^\\\\\\\\([^\\\\]+)",$m['dstDrive3rd'],$match)){
					$host = @$match[1];
					if(!empty($m['dstDrive3rdUsername'])){
						$data[$taskNo]['dstDrive3rdUsername'] = $host."\\".$m['dstDrive3rdUsername'];
					}
				}
				$i++;
			}
			$this->set(compact('data'));
			$this->render();
		}
	}
	/**
	 * SBCS用バックアップ終了通知
	 */
	function backupCompleted($accountID) {
		$accountID = (int)$accountID;
		$res = false;
		try {
			if(empty($accountID)) throw new Exception ('wrong parameter:accountid');
			$account = $this->Account->accountExists($accountID);
			if(empty($account)) throw new Exception ('empty account');
			$res = $this->SbcStatusHistory->saveBackupFinished($accountID);
			if(!$res) throw new Exception ('save failed');
		} catch (Exception $e) {
			$this->setErrors($e->getMessage());
		}
		echo ($res) ? '0' : '1';
		exit;
	}

	/**
	 * gssファイル書き出し
	 * 読み替えように[Var]セクションを書き出す
	 */
	function exportGssIni() {
		$res = $this->_exportGssIni();
		if($res) {
			echo '0';
		} else {
			echo '1';
		}
	}

	function _updateMaintenanceIniFile($debug = null, $runCmd = true) {
		$this->layout = false;
		$this->autoRender = false;
		$res = false;
		try {
			$this->Maintenance->setActiveUsers($this->MaintenanceSchedule->_getActiveUsers());

			$data = $this->MaintenanceSchedule->find('all', array(
				'conditions' => array(
					"MaintenanceSchedule.isActive = '1'"
				),
				'order' => array(
					'id' => 'asc'
				)
			));
			if(!empty($data)) {
				foreach($data as $index => $schedule) {
					$m = $schedule['MaintenanceSchedule'];
					if($m['target'] == 'all') {
						$data[$index]['MaintenanceSchedule']['userList'] = $this->Account->srcDirToUserList($m['srcDir'], $m['ClassName']);
					}
				}
				$this->Maintenance->saveIni($data);
			}
			if($runCmd === true) {
				$this->Cmd->run_sbl('reloadparams');
			}
			$res = true;
		} catch (Exception $e) {
			$res = false;
			echo $e->getMessage() . PHP_EOL;
			echo $e->getCode();
		}
		return $res;
	}

	/* duin再作成 */
	function create_duin() {
		$this->layout = false;
		$this->autoRender = false;
		if($this->_exportSizefile()) {
			echo "0";
		}
		exit;
	}
}
